function chart(reporting) {
    "use strict";

    var model = openerp;

    reporting.ReportChartWidget = reporting.Base.extend({

        BuildDemoChart: function (label,data,CurrencyBase) {
            var self = this;
            Chart.scaleService.updateScaleDefaults('linear', {
                ticks: {
                    callback: function(tick) {
                        return tick.toLocaleString('de-DE');
                    }
                }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };

            var chartData = {
    			labels: label,
    			datasets: [{
    				type: 'line',
    				label: 'Balance',
    				borderColor: '#0288d1',
                    fill:false,
    				data: [
                        '10500',
                        '5000',
                        '3000',
                        '19000',
                        '4000',
                        '70000',
                        '8000',
                        '43000',
                        '25000',
                        '39000',
                        '36000',
                        '47000',
    				],
    				borderWidth: 2
    			}, {
    				type: 'bar',
    				label: 'Ventas',
                    backgroundColor: '#81c784',
    				borderWidth: 1,
    				data: [
                        '10000',
                        '5000',
                        '3000',
                        '15000',
                        '45000',
                        '70000',
                        '90000',
                        '40000',
                        '25000',
                        '70000',
                        '30000',
                        '50000',
    				]
    			}, {
    				type: 'bar',
    				label: 'Compras',
    				backgroundColor: '#ffb74d',
    				data: [
                        '10000',
                        '5000',
                        '3000',
                        '15000',
                        '4000',
                        '70000',
                        '8000',
                        '40000',
                        '25000',
                        '35000',
                        '30000',
                        '40000',
    				],
    				borderWidth: 1
    			}, {
    				type: 'bar',
    				label: 'Gastos',
    				backgroundColor: '#e57373',
    				data: [
                        '10500',
                        '5000',
                        '3000',
                        '19000',
                        '4000',
                        '70000',
                        '8000',
                        '43000',
                        '25000',
                        '39000',
                        '36000',
                        '47000',
    				],
    				borderWidth: 1
    			}]
    		};
            var chart = new Chart($(".reporting-chart"), {
                type: 'bar',
                data: chartData,
                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    // events: ['click'],
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.yLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    }
                }
            });
        },

        BuildLineChart: function (label,data,CurrencyBase) {
            var self = this;
            Chart.scaleService.updateScaleDefaults('linear', {
                ticks: {
                    callback: function(tick) {
                        return tick.toLocaleString('de-DE');
                    }
                }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };
            var chart = new Chart($(".reporting-chart"), {
                type: 'line',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: data,
                            backgroundColor: '#bbdefb',
                            borderColor: '#0288d1',
                            borderWidth: 1,
                            fill: true,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    events: ['click'],
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.yLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    }
                }
            });
        },

        BuildBarChart: function (data,CurrencyBase,label,body) {
            var self = this;
            Chart.scaleService.updateScaleDefaults('linear', {
              ticks: {
                callback: function(tick) {
                    return tick.toLocaleString('de-DE');
                }
              }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };

            var color = [];
            color.push('#BCCEF4');
            color.push('#A9E5E3');
            color.push('#A0D995');
            color.push('#C5D084');
            color.push('#FAE187');
            color.push('#FFBD82');
            color.push('#FFA8B8');
            color.push('#E5BEDD');
            color.push('#C4ABFE');
            color.push('#D8D8D8');

            var chart = new Chart($(".reporting-chart"), {
                type: 'horizontalBar',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: body,
                            backgroundColor: color,
                            fill: true,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.xLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },

        BuildPieChart: function (data,CurrencyBase,label,body) {
            var self = this;

            var color = [];
            color.push('#BCCEF4');
            color.push('#A9E5E3');
            color.push('#A0D995');
            color.push('#C5D084');
            color.push('#FAE187');
            color.push('#FFBD82');
            color.push('#FFA8B8');
            color.push('#E5BEDD');
            color.push('#C4ABFE');
            color.push('#D8D8D8');
            color.push('#f3e5f5');

            var chart = new Chart($(".reporting-pie-chart"), {
                type: 'pie',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: body,
                            backgroundColor: color,
                            fill: true,
                        }
                    ]
                },

                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                        position: 'right',
                        // position: 'none',
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.labels[tooltipItem.index] || '';
                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(data.datasets[0].data[tooltipItem.index],{
                                    symbol: "%",
                                    format: "%v%s",
                                    precision: 2,
                                    thousand: ".",
                                    decimal: ","
                                });
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },

        BuildDoughnutChart: function (data,CurrencyBase,label,body) {
            var self = this;

            var color = [];
            color.push('#BCCEF4');
            color.push('#A9E5E3');
            color.push('#A0D995');
            color.push('#C5D084');
            color.push('#FAE187');
            color.push('#FFBD82');
            color.push('#FFA8B8');
            color.push('#E5BEDD');
            color.push('#C4ABFE');
            color.push('#D8D8D8');

            var chart = new Chart($(".reporting-doughnut-chart"), {
                type: 'doughnut',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: body,
                            backgroundColor: color,
                            fill: true,
                        }
                    ]
                },

                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                        position: 'left',
                        // position: 'none',
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.labels[tooltipItem.index] || '';
                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(data.datasets[0].data[tooltipItem.index],{
                                    symbol: "%",
                                    format: "%v%s",
                                    precision: 2,
                                    thousand: ".",
                                    decimal: ","
                                });
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },

        BuildMultipleChart: function (CurrencyBase,label,body_subtotal,body_tax,body_cost,body_total,body_profit) {
            var self = this;
            Chart.scaleService.updateScaleDefaults('linear', {
                ticks: {
                    callback: function(tick) {
                        return tick.toLocaleString('de-DE');
                    }
                }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };

            var chartData = {
    			labels: label,
    			datasets: [
                    /*
                    ================
                        BENEFICIO
                    ================
                    */
                    {
    				type: 'line',
    				label: 'Beneficio',
                    borderColor: '#03a9f4',
                    fill: false,
                    borderWidth: 2,
    				data: body_profit,

                    },
                    /*
                    ================
                        TOTAL
                    ================
                    */
                    {
    				type: 'bar',
    				label: 'Total',
                    borderColor: '#BCCEF4',
    				backgroundColor: '#BCCEF4',
                    borderWidth: 1,
    				data: body_total,
                    },
                    /*
                    ================
                        SUB TOTAL
                    ================
                    */
                    {
    				type: 'bar',
    				label: 'Sub-Total',
    				borderColor: '#A9E5E3',
                    backgroundColor: '#A9E5E3',
    				borderWidth: 1,
    				data: body_subtotal,
    			    },
                    /*
                    ================
                        IMPUESTOS
                    ================
                    */
                    {
    				type: 'bar',
    				label: 'Impuestos',
                    borderColor: '#A0D995',
    				backgroundColor: '#A0D995',
                    borderWidth: 1,
    				data:body_tax,
    			    },
                    /*
                    ================
                        COSTE
                    ================
                    */
                    {
    				type: 'bar',
    				label: 'Coste',
                    borderColor: '#C5D084',
    				backgroundColor: '#C5D084',
                    borderWidth: 1,
    				data: body_cost,
                    },
                ]
    		};
            var chart = new Chart($(".reporting-chart"), {
                type: 'bar',
                data: chartData,
                options: {
                    responsive: true,
                    responsiveAnimationDuration:20,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 15,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    events: ['click'],
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.yLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    }
                }
            });
        },

        BuildMultipleBarChart: function (
            data,
            CurrencyBase,
            first_label,
            first_body,
            second_label,
            second_body,
            third_label,
            third_body,
            fourth_label,
            fourth_body,
            label
            ) {
            var self = this;
            Chart.scaleService.updateScaleDefaults('linear', {
                ticks: {
                    callback: function(tick) {
                        return tick.toLocaleString('de-DE');
                    }
                }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };

            var chartData = {
    			labels: label,
    			datasets: [

                    {
    				type: 'bar',
    				label: first_label,
                    borderColor: '#BCCEF4',
    				backgroundColor: '#BCCEF4',
                    borderWidth: 1,
    				data: first_body,
                    },

                    {
    				type: 'bar',
    				label: second_label,
    				borderColor: '#A9E5E3',
                    backgroundColor: '#A9E5E3',
    				borderWidth: 1,
    				data: second_body,
    			    },

                    {
    				type: 'bar',
    				label: third_label,
                    borderColor: '#A0D995',
    				backgroundColor: '#A0D995',
                    borderWidth: 1,
    				data: third_body,
    			    },

                    {
    				type: 'bar',
    				label: fourth_label,
                    borderColor: '#0288d1',
    				backgroundColor: '#0288d1',
                    borderWidth: 1,
    				data: fourth_body,
    			    },
                ]
    		};

            var chart = new Chart($(".reporting-chart"), {
                type: 'bar',
                data: chartData,
                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.yLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },
        drawPdf4: function(row,ResCompany,pdf_title,pdf_type,pdf_name,pdf_columnStyles,filter){
         var self = this;
         var base64Img = 'data:image/png;base64,' + ResCompany.logo;
         var hoy = moment().format('DD/MM/YYYY');
         var totalPagesExp = "{total_pages_count_string}";
         var pdfDoc = new jsPDF(pdf_type);
         var title = [];
         var currentpage = 0;
         var i = 0;
         var position = 27;
         var y_position2 = 27;

         title.push({
           title : 'Factura',
           dataKey: 'invoice',
         });
         title.push({
           title : 'Cuota',
           dataKey: 'name',
         });
         title.push({
           title : 'Fecha de Vencimiento',
           dataKey: 'date',
         });
         title.push({
           title : 'Estado',
           dataKey: 'state',
         });
         title.push({
           title : 'Días Atrasados',
           dataKey: 'days_of_delays',
         });
         title.push({
           title : 'Total',
           dataKey: 'amount',
         });
         title.push({
           title : 'Saldo',
           dataKey: 'residual',
         });
         title.push({
           title : 'Saldo Factura',
           dataKey: 'invoice_residual',
         });

         //LOGO
         pdfDoc.addImage(base64Img, 'png', 7, 2, 0, 15);

         //FECHA
         pdfDoc.setFontSize(13);
         pdfDoc.setFontStyle('normal');
         pdfDoc.setTextColor(40)
         pdfDoc.text(pdfDoc.internal.pageSize.getWidth() - 35, 12,hoy);

         //TITULO
         pdfDoc.setFontSize(15);
         pdfDoc.setFontStyle('bold');
         pdfDoc.setTextColor('#0288d1');
         pdfDoc.autoTableText(pdf_title, pdfDoc.internal.pageSize.getWidth() - 12, 18, {
           halign: 'right',
           valign: 'middle'
         });
         pdfDoc.setLineWidth(0.5);
         pdfDoc.setDrawColor('#424242');
         pdfDoc.line(10, 22, pdfDoc.internal.pageSize.getWidth() - 10 , 22);

         var ii=0;
         if(pdf_type == 'l'){
           var col1_title = 15;
           var col1_value = 55;
           var col2_title = 150;
           var col2_value = 190;
         }
         else{
           var col1_title = 10;
           var col1_value = 50;
           var col2_title = 110;
           var col2_value = 150;
         }
         if(filter.length >0){
           _.each(filter,function(item){
             if(ii<4){
               self.addFilter(pdfDoc,item.title,item.value,col1_title,col1_value,position);
               position = position + 5;
             }else{
               self.addFilter(pdfDoc,item.title,item.value,col2_title,col2_value,y_position2);
               y_position2 = y_position2 + 5;
             }
               ii++;
           });
           pdfDoc.setLineWidth(0.5);
           pdfDoc.setDrawColor('#424242');

           if(position >= y_position2){
             position = position;
             pdfDoc.line(10, position, pdfDoc.internal.pageSize.getWidth() - 10 , position);
           }else{
             position = y_position2;
             pdfDoc.line(10, y_position2, pdfDoc.internal.pageSize.getWidth() - 10 , y_position2);
           }
         }

         _.each(row, function(item){
           if(i > 0){
             let first = pdfDoc.autoTable.previous;
             position = first.finalY + 5;
           };

           var docItem = [];
           if(item.info != 'undefined'){
             _.each(item.info, function(index){
               docItem.push({
                 invoice: index.invoice,
                 name: index.name,
                 date: index.date,
                 state: index.state,
                 days_of_delays: index.days_of_delays,
                 amount: index.amount,
                 residual: index.residual,
                 invoice_residual: index.invoice_residual,
               })
             });
           }

           pdfDoc.setDrawColor(0);
           pdfDoc.setFillColor(76, 133, 248);
           pdfDoc.rect(7, position+5, 196, 8, 'F');

           pdfDoc.setFontSize(9);
           pdfDoc.setTextColor(255,255,255)
           pdfDoc.setFontStyle('bold');

           pdfDoc.autoTableText('Cliente: ', 10, position+9, {
             halign: 'left',
             valign: 'middle'
           });

           pdfDoc.autoTableText(item.partner_name, 22, position+9, {
             halign: 'left',
             valign: 'middle'
           });

           pdfDoc.autoTableText('Cuotas Vencidas: ', 80, position+9, {
             halign: 'left',
             valign: 'middle'
           });

           pdfDoc.autoTableText(item.due_qty.toString(), 108, position+9, {
             halign: 'left',
             valign: 'middle'
           });

           pdfDoc.autoTableText('Días Atrasados: ', 115, position+9, {
             halign: 'left',
             valign: 'middle'
           });

           pdfDoc.autoTableText(item.max_days_of_delay.toString(), 140, position+9, {
             halign: 'left',
             valign: 'middle'
           });

           pdfDoc.autoTableText('Monto Atrasado: ', 148, position+9, {
             halign: 'left',
             valign: 'middle'
           });

           pdfDoc.autoTableText(item.amount, 175, position+9, {
             halign: 'left',
             valign: 'middle'
           });

           pdfDoc.autoTable(title, docItem, {
             //  showHeader: false,
             startY: position+15,
             theme: 'grid',
             styles: {
               overflow: 'linebreak',
               fontSize: 8,
               margin: 50,
               lineWidth: 0.3,
               lineColor: [132,132,132]
             },

             headerStyles: {
               fillColor: [255,255,255],
               fontSize: 9,
               textColor: [0,0,0],
               lineWidth: 0.3,
               lineColor: [132,132,132],
               halign: 'center',
             },
             columnStyles: pdf_columnStyles,
             margin: 'auto',
             tableWidth: 'auto',

             addPageContent: function (data) {
               // FOOTER
               if (currentpage < pdfDoc.internal.getNumberOfPages()) {
                 var str = "Página " + pdfDoc.internal.getNumberOfPages();
                 str = str + " de " + totalPagesExp;
                 pdfDoc.setFontSize(9);
                 pdfDoc.setFontStyle('bold');
                 pdfDoc.setTextColor(40);
                 var pageHeight = pdfDoc.internal.pageSize.height || pdfDoc.internal.pageSize.getHeight();
                 pdfDoc.text(str, pdfDoc.internal.pageSize.getWidth() - 55, pageHeight - 5);
                 currentpage = pdfDoc.internal.getNumberOfPages();
               }
             }
           });
           i++;
         });
         if(typeof pdfDoc.putTotalPages === 'function'){
           pdfDoc.putTotalPages(totalPagesExp);
         }
         row.pop();
         if(model.printer_bridge){
           var data = pdfDoc.output('datauristring');
           model.printer_bridge.print(data);
           return;
         }
         pdfDoc.save(pdf_name + hoy + '.pdf');
       },

       addFilter: function(pdfDoc,title,value,x_position_title,x_position_value,y_position){
            pdfDoc.setFontSize(10);
            pdfDoc.setTextColor('#424242');
            pdfDoc.setFontStyle('bold');
            pdfDoc.autoTableText(title+':', x_position_title, y_position, {
              halign: 'left',
              valign: 'middle'
            });
            pdfDoc.setFontSize(10);
            pdfDoc.setTextColor('#424242');
            pdfDoc.setFontStyle('normal');
            pdfDoc.autoTableText(value, x_position_value, y_position, {
              halign: 'left',
              valign: 'middle'
            });
      },
    });
}
