function report_daily_sale(reporting){
  "use strict";

  var model = openerp;

  reporting.ReportDailySaleWidget = reporting.Base.extend({
    template: 'ReportDailySale',
    rowsData :[],
    content :[],
    modules: ['point_of_sale'],

    events:{
      'click #toolbar > button' : 'clickOnAction',
      'click #generate' : 'fetchGenerate',
      'change #current-company' : 'updateSelections',
      'change #current-date' : 'ShowDateRange',
      'change #current-period' : 'updatePeriodSelections',
    },

    init : function(parent){
      this._super(parent);
    },

    start: function () {
      var table = this.$el.find('#table');
      table.bootstrapTable({data : self.rowsData});
      var date = new reporting.ReportDatePickerWidget(self);
      date.fecthFecha();
      this.fetchInitial();
    },

    checkModel : function(model){
      var self = this;
      return _.filter(self.IrModuleModule,function(item){
        return item.name === model
      });
    },

    valorNull:function(dato){
      var valor = "";
      if (dato){
        valor = dato;
      }
      return valor;
    },

    ShowDateRange : function(){
      var self = this;
      var date = self.$el.find('#current-date').val();
      if(date == 'range'){
        self.$el.find('.datepicker').css('display','block');
      }
      if(date != 'range'){
        self.$el.find('.datepicker').css('display','none');
      }
    },

      fetchInitial: function () {
        var self = this;
        self.fecthIrModuleModule().then(function (IrModuleModule) {
          return IrModuleModule;
        }).then(function(IrModuleModule) {
          self.IrModuleModule = IrModuleModule;
          return self.fetchResUser();
        }).then(function (ResUser) {
          self.ResUser = ResUser;
          if(ResUser.length > 1){
            self.$el.find('#current-user').append('<option value="9999999">Todos los vendedores</option>');
            _.each(ResUser,function(item){
              self.$el.find('#current-user').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
          }else{
            self.$el.find('.user').css('display','none');
          }
          self.fecthCheckType();
          return self.fetchResCompany();
        }).then(function(ResCompany){
          self.ResCompany = ResCompany;
          if(ResCompany.length > 1){
            self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
            _.each(ResCompany,function(item){
              self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
          }else{
            self.$el.find('.company').css('display','none');
          }
          return self.fetchResStore();
        }).then(function(ResStore){
          self.ResStore = ResStore;
          if(ResStore.length > 1){
            self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
            _.each(ResStore,function(item){
              self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
          }else{
            self.$el.find('.store').css('display','none');
          }
          return self.fetchAccountPeriod();
        }).then(function(AccountPeriod){
          self.AccountPeriod = AccountPeriod;
          self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
          _.each(AccountPeriod,function(item){
            self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
          return self.fetchResCurrency();
        }).then(function(ResCurrency){
          self.ResCurrency = ResCurrency;
        });
        self.$el.find('#generate').css('display','inline');
        return;
      },

      fetchGenerate: function () {
        var self = this;
        self.$el.find('.search-form').block({
          message: null,
          overlayCSS: {
            backgroundColor: '#FAFAFA'
          }
        });
        self.$el.find('.report-form').block({
          message: null,
          overlayCSS: {
            backgroundColor: '#FAFAFA'
          }
        });

        this.fetchAccountInvoice().then(function(AccountInvoice) {
          return AccountInvoice;
        }).then(function (AccountInvoice) {
          self.AccountInvoice = AccountInvoice;
          return self.fetchPosOrder();
        }).then(function (PosOrder){
          self.PosOrder = PosOrder;
          return self.fetchPosOrderLine();
        }).then(function (PosOrderLine){
          self.PosOrderLine = PosOrderLine;
          return self.fetchAccountInvoiceLine();
        }).then(function(AccountInvoiceLine){
          self.AccountInvoiceLine = AccountInvoiceLine;
          return self.fetchResUser();
        }).then(function(ResUser){
          self.ResUser = ResUser;
          return self.BuildTable();
        });
      },

/*=====================================================================
            IR MODULE
=====================================================================*/
      fecthIrModuleModule: function(){
        var self = this;
        var defer = $.Deferred();
        var fields = ['name','id'];
        var domain=[['state','=','installed'],['name','in',self.modules]];
        var IrModuleModule = new model.web.Model('ir.module.module');
        IrModuleModule.query(fields).filter(domain).all().then(function(results){
          defer.resolve(results);
        })
        return defer;
      },

/*=====================================================================
            Check type
=====================================================================*/
      fecthCheckType: function(){
        var self = this;
        var modules = self.checkModel('point_of_sale');
        if(modules.length == 0){
          self.$el.find('.type').css('display','none');
        }
      },

/*=====================================================================
            USER
=====================================================================*/
      fetchResUser: function() {
        var self = this;
        var domain = [];
        var defer = $.Deferred();
        var fields = ['id','name','store_id','company_id'];
        var user = self.$el.find('#current-user').val();
        var store = self.$el.find('#current-store').val();
        var company = self.$el.find('#current-company').val();

        if(company && company != 9999999){
          domain.push(['company_id','=',parseInt(company)]);
        }

        if(user && user != 9999999){
          domain.push(['id','=', parseInt(user)]);
        }
        if(store && store != 9999999){
          domain.push(['store_id','=',parseInt(store)]);
        }

        var ResUser = new model.web.Model('res.users');
        ResUser.query(fields).filter(domain).all().then(function (results) {
          defer.resolve(results);
        });
        return defer;
      },

/*=====================================================================
            ACCOUNT PERIOD
=====================================================================*/
      fetchAccountPeriod: function () {
        var self = this;
        var defer = $.Deferred();
        var domain = [['special','=',false]];
        var field =['id', 'name', 'date_start','date_stop','company_id'];
        var AccountPeriod = new model.web.Model('account.period');
        AccountPeriod.query(field).filter(domain).all().then(function (results) {
          defer.resolve(results);
        });
        return defer;
      },

/*====================================================================
            RES STORE
====================================================================*/
      fetchResStore: function(){
        var self = this;
        var defer = $.Deferred();
        var field = ['id','name','company_id'];
        var ResStore = new model.web.Model('res.store');
        ResStore.query(field).all().then(function(results){
          defer.resolve(results);
        });
        return defer;
      },

/*====================================================================
            ACCOUNT INVOICE
====================================================================*/
      fetchAccountInvoice: function () {
        var self = this;
        var period = self.$el.find('#current-period').val();
        var date = self.$el.find('#current-date').val();
        var desde = self.$el.find('#from').val();
        var hasta = self.$el.find('#to').val();

        var domain = [
          ['state', 'in',['open','paid']],
          ['type', '=', 'out_invoice'],
        ];

        if(period != 9999999){
          domain.push(['period_id','=',parseInt(period)]);
        }

        if(date && date != 9999999){
          if(desde){
            var date = desde.split('/')
            date = (date[2]+"-"+date[1]+"-"+date[0]);
            domain.push(['date_invoice','>=',date]);
          }

          if(hasta){
            var date = hasta.split('/')
            date = (date[2]+"-"+date[1]+"-"+date[0]);
            domain.push(['date_invoice','<=',date]);
          }

          if(date == 'today'){
            var today = moment().format('YYYY-MM-DD');
            domain.push(['date_invoice','=',today]);
          }

          if(date == 'yesterday'){
            var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
            domain.push(['date_invoice','=',yesterday]);
          }

          if(date == 'currentMonth'){
            var currentMonth = moment().format('YYYY-MM');
            domain.push(['date_invoice','like',currentMonth]);
          }

          if(date == 'lastMonth'){
            var lastMonth = moment().add(-1,'months').format('YYYY-MM');
            domain.push(['date_invoice','like',lastMonth]);
          }
        }

        var AccountInvoice = new model.web.Model('account.invoice');
        return AccountInvoice.call('getAccountInvoice',[domain], {
          context: new model.web.CompoundContext()
        });
      },


      fetchAccountInvoiceLine: function () {
        var self = this;
        var invoice_ids = _.flatten(_.map(self.AccountInvoice, function (item) {
            return item.id;
        }));
        var domain = [
            ['invoice_id','in',invoice_ids],
        ];

        var AccountInvoiceLine = new model.web.Model('account.invoice.line');
        return AccountInvoiceLine.call('getAccountInvoiceLine',[domain], {
          context: new model.web.CompoundContext()
        });
      },


/*====================================================================
            POS ORDER
====================================================================*/
      fetchPosOrder: function () {
        var self = this;
        var type = $('#current-type').val();
        var modules = self.checkModel('point_of_sale');
        if (type && modules.length > 0){
          if(type != 'sale'){

            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();

            var domain = [
              ['state', 'not in',['draft','cancel']],
            ];

            if(date && date != 9999999){
              if(desde){
                var date = desde.split('/')
                date = (date[2]+"-"+date[1]+"-"+date[0]);
                domain.push(['date_order','>=',date]);
              }
            }

            var PosOrder = new model.web.Model('account.invoice');
            return PosOrder.call('getPosOrder',[domain], {
              context: new model.web.CompoundContext()
            });
          }
        }else{
          var PosOrder = [];
          return PosOrder;
        }
      },

      fetchPosOrderLine: function () {
        var self = this;
        var domain = [];
        var order_ids = _.flatten(_.map(self.PosOrder, function (item) {
            return item.id;
        }));
        var domain = [
            ['order_id','in',order_ids],
        ];

        var modules = self.checkModel('point_of_sale');
        if (modules.length > 0){
          var PosOrderLine = new model.web.Model('account.invoice.line');
          return PosOrderLine.call('getPosOrderLine',[domain], {
              context: new model.web.CompoundContext()
          });
        }else{
            var PosOrderLine = [];
            return PosOrderLine;
        }
      },

/*====================================================================
            RES COMPANY
====================================================================*/
      fetchResCompany: function(){
        var self = this;
        var defer = $.Deferred();
        var currency = new model.web.Model('res.company');
        var field=['id','name','currency_id','logo'];
        currency.query(field).filter().all().then(function(results){
          defer.resolve(results);
        });
        return defer;
      },

/*====================================================================
            RES CURRENCY
====================================================================*/
      fetchResCurrency : function(){
        var self = this;
        var defer = $.Deferred();
        var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
        var domain = [['active', '=', true]];
        var ResCurrency = new model.web.Model('res.currency');
        ResCurrency.query(fields).filter(domain).all().then(function(results) {
          defer.resolve(results);
        });
        return defer;
      },

/*====================================================================
            UPDATE SELECTIONS
====================================================================*/
      updateSelections: function () {
        var self = this;
        var company = self.$el.find('#current-company').val();
        if(company != 9999999){
          /*===================
              STORE SELECTION
          ==================*/
          var store = self.$el.find('#current-store').empty();
          self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
          _.each(self.ResStore,function(item){
            if(parseFloat(company) == item.company_id[0]){
              self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
            }
          });
          /*====================
                PERIOD SELECTION
          ====================*/
          var period = self.$el.find('#current-period').empty();
          self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
          _.each(self.AccountPeriod,function(item){
            if(parseFloat(company) == item.company_id[0]){
              self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
            }
          });
        }else{
          /*===================
              STORE SELECTION
          ===================*/
          var store = self.$el.find('#current-store').empty();
          self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
          _.each(self.ResStore,function(item){
            self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
          /*====================
              PERIOD SELECTION
            ====================*/
          var period = self.$el.find('#current-period').empty();
          self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
          _.each(self.AccountPeriod,function(item){
            self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        }
      },

      updatePeriodSelections: function () {
          var self = this;
          var period = self.$el.find('#current-period').val();
          if(period != 9999999){
              self.$el.find('#current-date').val(9999999);
              self.$el.find('#current-date').prop('disabled','disabled');
              self.$el.find('.datepicker').css('display','none');
          }else{
              self.$el.find('#current-date').prop('disabled',false);
          }
      },

/*====================================================================
          GET RES COMPANY
====================================================================*/
      getResCompany: function (id) {
        var self = this;
        return _.filter(self.ResCompany,function (item) {
          return item.id == id;
        })
      },

/*====================================================================
            GET RES CURRENCY BASE
====================================================================*/
      getResCurrency: function (id) {
        var self = this;
        return _.filter(self.ResCurrency,function (item) {
          return item.id === id;
        })
      },

/*============================
            ACCOUNT DATA BY MONTH
============================*/
      getContent:function(mes) {
        var self = this;
        return _.flatten(_.filter(self.content,function (inv) {
          return moment(inv.date).format('YYYY-MM') === moment(mes).format('YYYY-MM');
        }));
      },
/*============================
            GET POS ORDER
============================*/
      getPosOrder:function(id) {
        var self = this;
        var date = self.$el.find('#current-date').val();
        var period = self.$el.find('#current-period').val();
        var desde = self.$el.find('#from').val();
        var hasta = self.$el.find('#to').val();
        var content = _.filter(self.PosOrder,function (inv) {
          return inv.user_id[0] == id;
        });
          if(date && date != 9999999){
            if(desde){
              var date = desde.split('/')
              date = (date[2]+"-"+date[1]+"-"+date[0]);
              content = _.flatten(_.filter(content,function (inv) {
                var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                return moment(utc).format('YYYY-MM-DD') >= desde;
              }));
            }
            if(hasta){
              var date = desde.split('/')
              date = (date[2]+"-"+date[1]+"-"+date[0]);
              content = _.flatten(_.filter(content,function (inv) {
                var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                return moment(utc).format('YYYY-MM-DD') <= hasta;
              }));
            }
            if(date == 'today'){
              var today = moment().format('YYYY-MM-DD');
              content = _.flatten(_.filter(content,function (inv) {
                var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                return moment(utc).format('YYYY-MM-DD') === today;
              }));
            }
            if(date == 'yesterday'){
              var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
              content = _.flatten(_.filter(content,function (inv) {
                var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                return moment(utc).format('YYYY-MM-DD') === yesterday;
              }));
            }
            if(date == 'currentMonth'){
              var currentMonth = moment().format('YYYY-MM');
              content = _.flatten(_.filter(content,function (inv) {
                var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                return moment(utc).format('YYYY-MM') === currentMonth;
              }));
            }
            if(date == 'lastMonth'){
              var lastMonth = moment().add(-1,'months').format('YYYY-MM');
              content = _.flatten(_.filter(content,function (inv) {
                var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                return moment(utc).format('YYYY-MM') === lastMonth;
              }));
            }
          }
          if(period && period != 9999999){
            var data = _.filter(self.AccountPeriod,function (inv) {
              return inv.id == parseInt(period);
            });
            content = _.flatten(_.filter(content,function (inv) {
              var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
              utc = moment(utc._d).format('YYYY-MM-DD');
              return moment(utc).format('MM/YYYY') === data[0].name;
            }));
          }

          return content;
      },

      getPosOrderLine: function (id) {
        var self = this;
        return _.filter(self.PosOrderLine,function (item) {
            return item.order_id[0] == id;
        });
      },

      getAccountInvoice: function (id) {
        var self = this;
        return _.filter(self.AccountInvoice,function (item) {
          return item.user_id[0] === id;
        })
      },

      getAccountInvoiceLine: function (id) {
        var self = this;
        return _.filter(self.AccountInvoiceLine,function (item) {
          return item.invoice_id === id;
        })
      },

        /*====================================================================
            BUILD
        ====================================================================*/
      BuildTable: function(){
        var self = this;
        var data = [];
        var all_data = [];
        var AccountInvoice = [];
        var PosOrder = [];

        var type = $('#current-type').val();
        var company = $('#current-company').val();
        if(company && company != 9999999){
          var ResCompany = self.getResCompany(company).shift();
          var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
        }else{
          var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
        }

        var ResUser = self.ResUser;
        _.each(ResUser, function(user){
          var info=[];
          var header_qty = 0;
          var header_price = 0;

          if(type == 'sale' || type == 9999999){
            AccountInvoice =_.map(self.getAccountInvoice(user.id), function(item){
              item.group_type= 'sale';
              return item;
            });
          }
          if(type == 'tpv' || type == 9999999){
            PosOrder =_.map(self.getPosOrder(user.id), function(item){
              item.group_type= 'tpv';
              return item;
            });
          }

          var concatBothSaleType = AccountInvoice.concat(PosOrder);
          var grouped_data = self.groupBy(concatBothSaleType);

          grouped_data.forEach((item,key) => {

            var sum_qty=0;
            var sum_price=0;
            var sum_qty_pos=0;
            var sum_price_pos=0;
            var total_qty =0;
            var total_price=0;
            var total_average =0;

            _.each(item, function(item2){//1
              if(item2.group_type == 'sale'){
                var AccountInvoiceLine = self.getAccountInvoiceLine(item2.id);
                _.each(AccountInvoiceLine, function(item3){
                  sum_qty = sum_qty + item3.quantity;
                  sum_price = sum_price + (item3.price_unit * item3.quantity);
                });
              }
              if(item2.group_type == 'tpv'){
                var PosOrderLine = self.getPosOrderLine(item2.id);
                _.each(PosOrderLine, function(item3){
                  sum_qty_pos = sum_qty_pos + item3.qty;
                  sum_price_pos = sum_price_pos + (item3.price_unit * item3.qty);
                });
              }
            });//1

            //suma venta normal + pos

            total_qty = sum_qty + sum_qty_pos;
            total_price = sum_price + sum_price_pos;
            total_average = total_price / total_qty;
            header_qty = header_qty + total_qty;
            header_price = header_price + total_price;

            info.push({
              date: moment(key).format('DD/MM/YYYY'),
              store: user.store_id[1],
              user: user.name,
              qty: accounting.formatNumber(total_qty, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
              price: accounting.formatMoney(total_price, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
              average: accounting.formatMoney(total_average, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
            });

            info.sort(function(a, b) {
              a = new Date(moment(a.date).format('DD/MM/YYYY'));
              b = new Date(moment(b.date).format('DD/MM/YYYY'));
              return a>b ? -1 : a<b ? 1 : 0;
            });
          });

          if( header_price > 0){
            data.push({
              user: user.name,
              qty: accounting.formatNumber(header_qty, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
              price: accounting.formatMoney(header_price, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),

              qty_no_format : header_qty,
              price_no_format: header_price,

              decimal_places : CurrencyBase.decimal_places,
              thousands_separator: CurrencyBase.thousands_separator,
              decimal_separator: CurrencyBase.decimal_separator,

              info:info,
            });
          }
        });

        self.content = data;
        self.loadTable(data);
        self.$el.find('.report-form').css('display','block');
        self.$el.find('.search-form').unblock();
        self.$el.find('.report-form').unblock();
      },

      groupBy: function(list) {
        const map = new Map();
        list.forEach((item) => {
          const key = item.date_invoice || moment(item.date_order).format('YYYY-MM-DD');
          const collection = map.get(key);
          if (!collection) {
            map.set(key, [item]);
          } else {
            collection.push(item);
          }
        });
        return map;
      },


/*====================================================================
            LOAD BOOTSTRAP TABLE
====================================================================*/
      loadTable:function(rowsTable){
        var self = this;
        self.rowsData = rowsTable;
        var table = this.$el.find('#table');
        table.bootstrapTable('load', rowsTable);
      },

/*====================================================================
            PRINT PDF
====================================================================*/
      clickOnAction: function (e) {
        var self = this;
        var ResCompany;
        var action = this.$el.find(e.target).val();
        var company = $('#current-company').val();
        if(company && company != 9999999){
          ResCompany = self.getResCompany(company).shift();
          var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
        }else{
          ResCompany = self.ResCompany[0];
          var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
        }
        var getColumns=[];
        var rows=[];
        var table = this.$el.find("#table");
        var column = table.bootstrapTable('getVisibleColumns');
        var row = table.bootstrapTable('getData');

        if (action === 'pdf') {
          var data = _.map(column, function (val){ return val.field});
          _.each(_.map(column,function(val){
            return val}), function(item){
              getColumns.push([{
                title: item.title,
                dataKey: item.field
              }]);
            });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
          var pdf_title = 'Resumen de Ventas Diarias.';
          var pdf_type = '';
          var pdf_name = 'resumen_ventas_diarias_';
          var pdf_columnStyles = {
            date :{halign:'center'},
            store :{halign:'left'},
            user : {halign:'left'},
            qty : {columnWidth: '20%', halign:'right'},
            price : {columnWidth: '20%', halign:'right'},
            average : {columnWidth: '20%', halign:'right'},
          };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
          var filter = self.getFilter();
          var pdf = new reporting.ReportPdfWidget(self);
          pdf.drawPdf3(
            row,
            ResCompany,
            pdf_title,
            pdf_type,
            pdf_name,
            pdf_columnStyles,
            filter,
          );
        }
      },
      getFilter: function(){
        var self = this;
        var company = self.$el.find('#current-company').val();
        var user = self.$el.find('#current-user').val();
        var store = self.$el.find('#current-store').val();
        var period = self.$el.find('#current-period').val();
        var type = self.$el.find('#current-type').val();
        var date = self.$el.find('#current-date').val();
        var desde = self.$el.find('#from').val();
        var hasta = self.$el.find('#to').val();

        var filter = [];
        if(company && company != 9999999){
          var ResCompany = _.filter(self.ResCompany, function(item){
            return item.id == company;
          });
          filter.push({
            title:'Empresa',
            value: ResCompany[0].name,
          });
        }

        if(user && user != 9999999){
          var ResUser = _.filter(self.ResUser, function(item){
            return item.id == user;
          })

          filter.push({
            title: 'Vendedor',
            value: ResUser[0].name,
          })
        }
        if(store && store != 9999999){
          var ResStore =  _.filter(self.ResStore,function (item) {
              return item.id == store;
          });

          filter.push({
              title: 'Sucursal',
              value:  ResStore[0].name,
          });
        }

        if(period && period != 9999999){
          var AccountPeriod =  _.filter(self.AccountPeriod,function (item) {
              return item.id == period;
          });
          filter.push({
               title: 'Periodo',
               value:  AccountPeriod[0].name,
             });
        }

      if(type && type != 9999999){
        filter.push({
          title: 'Tipo de Venta',
          value: $("#current-type option:selected").text(),
        })
      }

        if(date && date != 9999999){
          moment.locale('es', {
            months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
          });

          if(date == 'range'){
            filter.push({
                title: 'Fecha',
                value:  desde +' al '+hasta,
            });

          }
          else {
            if(date == 'today'){
                var fecha = moment().format('DD/MM/YYYY');
            }

            if(date == 'yesterday'){
                var fecha = moment().add(-1,'days').format('DD/MM/YYYY');
            }
            if(date == 'currentMonth'){
                var fecha = moment().format('MMMM/YYYY');
            }
            if(date == 'lastMonth'){
                var fecha = moment().add(-1,'months').format('MMMM/YYYY');
            }

            filter.push({
                title: 'Fecha',
                value:  fecha,
            });
          }
        }
        return filter;
      },
    });
}
