function report_income_summary(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportIncomeSummaryWidget = reporting.Base.extend({
        template: 'ReportIncomeSummary',
        rowsData :[],
        content :[],
        modules: ['point_of_sale'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'change #current-company' : 'updateSelections',
            'change #current-period' : 'updatePeriodSelections',
            'change #current-date' : 'ShowDateRange',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model
            });
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }

        },

        fetchInitial: function () {
            var self = this;
            self.fecthIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResUser();
            }).then(function (ResUser) {
                self.ResUser = ResUser;
                // self.fecthCheckType();
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                return self.fetchAccountPeriod();
            }).then(function(AccountPeriod){
                self.AccountPeriod = AccountPeriod;
                self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
                _.each(AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' +  item.id + '">' + item.name + '</option>');
                });
                return self.fetchResCurrency();
            }).then(function(ResCurrency){
                self.ResCurrency = ResCurrency;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });

            this.fetchAccountVoucher().then(function(AccountVoucher) {
                return AccountVoucher;
            }).then(function (AccountVoucher) {
                self.AccountVoucher = AccountVoucher;
                return self.fetchAccountBankStatementLine();
            }).then(function (AccountBankStatementLine) {
                self.AccountBankStatementLine = AccountBankStatementLine;
                return self.BuildTable();
            });
        },

        /*=====================================================================
            IR MODULE
        =====================================================================*/
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },

        /*=====================================================================
            USER
        =====================================================================*/
        fetchResUser: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','store_id'];
            var domain = [['id','=',self.session.uid]];
            var ResUser = new model.web.Model('res.users');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES COMPANY
        ====================================================================*/
        fetchResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id','name','currency_id','logo'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES STORE
        ====================================================================*/
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            ACCOUNT JOURNAL
        ====================================================================*/
        fetchAccountJournal: function(){
            var self = this;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var store_ids = _.flatten(_.map(self.ResStore, function (item) {
                return item.id;
            }));
            var domain = [
                ['active','=',true],
                ['type','in',['bank','cash']],
                ['store_ids','in',store_ids],
            ];
            if(company && company != 9999999){
               domain.push(['company_id','=',parseInt(company)]);
            }
            if(store && store != 9999999){
               domain.push(['store_ids','=',parseInt(store)]);
            }
            var AccountJournal = new model.web.Model('account.journal');
            return AccountJournal.call('getAccountJournal',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*=====================================================================
            ACCOUNT PERIOD
        =====================================================================*/
        fetchAccountPeriod: function () {
            var self = this;
            var defer = $.Deferred();
            var domain = [['special','=',false]];
            var field =['id', 'name', 'date_start','date_stop','company_id'];
            var AccountPeriod = new model.web.Model('account.period');
            AccountPeriod.query(field).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*=====================================================================
            ACCOUNT VOUCHER
        =====================================================================*/
        fetchAccountVoucher: function () {
            var self = this;
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var domain = [['state','=','posted'],['type','=','receipt']];
            var period = self.$el.find('#current-period').val();

            if(period && period != 9999999){
               domain.push(['period_id','=',parseInt(period)]);
            }

            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        var date = desde.split('/')
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        domain.push(['date','>=',date]);
                    }

                    if(hasta){
                        var date = hasta.split('/')
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        domain.push(['date','<=',date]);
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD 00:00:00');
                    domain.push(['date','>=',today]);
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD 00:00:00');
                    domain.push(['date','>=',yesterday]);
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    domain.push(['date','like',currentMonth]);
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    domain.push(['date','like',lastMonth]);
                }
            }
            var AccountVoucher = new model.web.Model('account.voucher');
            return AccountVoucher.call('getAccountVoucher',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*=====================================================================
            ACCOUNT BANK STATEMENT LINE
        =====================================================================*/
        fetchAccountBankStatementLine: function () {
            var self = this;
            var modules = self.checkModel('point_of_sale');
            if (modules.length > 0){
                var store = self.$el.find('#current-store').val();
                var date = self.$el.find('#current-date').val();
                var desde = self.$el.find('#from').val();
                var hasta = self.$el.find('#to').val();
                var period = self.$el.find('#current-period').val();
                var journal_ids = _.map(_.filter(self.AccountJournal,function (item) {
                    return item;
                }), function(map){
                    return map.id;
                });
                var domain = [
                    ['pos_statement_id','!=',false],
                    ['journal_id','in',journal_ids],
                ];
                if(store && store != 9999999){
                    var journal_ids = _.map(_.filter(self.AccountJournal,function (item) {
                        return item.store_ids == store;
                    }), function(map){
                        return map.id;
                    });
                }else{
                    var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                        return item.id;
                    }));
                }

                if(period && period != 9999999){
                    var data = _.filter(self.AccountPeriod,function (inv) {
                        return inv.id == parseInt(period);
                    });
                    domain.push(['date','>=',data[0].date_start]);
                    domain.push(['date','<=',data[0].date_stop]);
                }

                if(date && date != 9999999){
                    if(date == 'range'){
                        if(desde){
                            var date = desde.split('/')
                            date = (date[2]+"-"+date[1]+"-"+date[0]);
                            domain.push(['date','>=',date]);
                        }

                        if(hasta){
                            var date = hasta.split('/')
                            date = (date[2]+"-"+date[1]+"-"+date[0]);
                            domain.push(['date','<=',date]);
                        }
                    }

                    if(date == 'today'){
                        var today = moment().format('YYYY-MM-DD 00:00:00');
                        domain.push(['date','>=',today]);
                    }

                    if(date == 'yesterday'){
                        var yesterday = moment().add(-1,'days').format('YYYY-MM-DD 00:00:00');
                        domain.push(['date','>=',yesterday]);
                    }

                    if(date == 'currentMonth'){
                        var currentMonth = moment().format('YYYY-MM');
                        domain.push(['date','like',currentMonth]);
                    }

                    if(date == 'lastMonth'){
                        var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                        domain.push(['date','like',lastMonth]);
                    }
                }
                var AccountBankStatementLine = new model.web.Model('account.bank.statement.line');
                return AccountBankStatementLine.call('getAccountBankStatementLine',[domain], {
                    context: new model.web.CompoundContext()
                });
            }else{
                var AccountBankStatementLine = [];
                return AccountBankStatementLine;
            }
        },

        /*====================================================================
            RES CURRENCY
        ====================================================================*/
        fetchResCurrency : function(){
            var self = this;
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            return ResCurrency.call('getResCurrency',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },
        updatePeriodSelections: function () {
            var self = this;
            var period = self.$el.find('#current-period').val();
            if(period != 9999999){
                self.$el.find('#current-date').val(9999999);
                self.$el.find('#current-date').prop('disabled','disabled');
                self.$el.find('.datepicker').css('display','none');
            }else{
                self.$el.find('#current-date').prop('disabled',false);
            }
        },

        /*====================================================================
            GET RES COMPANY
        ====================================================================*/
        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },

        /*====================================================================
            GET RES CURRENCY BASE
        ====================================================================*/
        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },

        /*====================================================================
            GET ACCOUNT JOURNAL
        ====================================================================*/
        getAccountJournal: function (id) {
            var self = this;
            return _.filter(self.AccountJournal,function (item) {
                return item.store_ids[0] === id;
            })
        },
        /*====================================================================
            GET ACCOUNT VOUCHER
        ====================================================================*/
        getAccountVoucher: function (id) {
            var self = this;
            return _.filter(self.AccountVoucher,function (item) {
                return item.journal_id[0] === id;
            })
        },

        /*====================================================================
            GET ACCOUNT BANK STATEMENT LINE
        ====================================================================*/
        getAccountAccountBankStatementLine: function (id) {
            var self = this;
            return _.filter(self.AccountBankStatementLine,function (item) {
                return item.journal_id[0] === id;
            })
        },

        /*====================================================================
            GET RES STORE
        ====================================================================*/
        getResStore: function () {
            var self = this;
            var content = self.ResStore;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.company_id[0] === parseInt(company);
                }));
            }
            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.id === parseInt(store);
                }));
            }
            return content;
        },

        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
            var self = this;
            var data = [];
            var info = [];
            var ResStore = self.getResStore();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                var ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            };
            _.each(ResStore,function(item) {
                var AccountJournal = self.getAccountJournal(item.id);
                info = [];
                _.each(AccountJournal,function(index) {
                    var AccountVoucher = self.getAccountVoucher(index.id);
                    var AccountBankStatementLine = self.getAccountAccountBankStatementLine(index.id);
                    /*
                    ====================================================
                        AMOUNT IN CURRENCY BASE
                    ====================================================
                    */
                    var voucher_amount_currency = _.reduce(_.map(AccountVoucher, function (map) {
                        return map.amount_currency
                    }), function (meno,num) {
                        return meno + num
                    }, 0);
                    var account_bank_statement_line_amount_currency = _.reduce(_.map(AccountBankStatementLine, function (map) {
                        return map.amount_currency
                    }), function (meno,num) {
                        return meno + num
                    }, 0);
                    /*
                    ====================================================
                        AMOUNT IN CURRENCY
                    ====================================================
                    */
                    if(index.currency[0]){
                        var voucher_amount = _.reduce(_.map(AccountVoucher, function (map) {
                            return map.amount
                        }), function (meno,num) {
                            return meno + num
                        }, 0);
                        var account_bank_statement_line_amount = _.reduce(_.map(AccountBankStatementLine, function (map) {
                            return map.amount
                        }), function (meno,num) {
                            return meno + num
                        }, 0);
                    }
                    /*
                    ====================================================
                        TOTAL IN CURRENCY BASE
                    ====================================================
                    */
                    var amount_currency = voucher_amount_currency + account_bank_statement_line_amount_currency;
                    /*
                    ====================================================
                        TOTAL IN CURRENCY
                    ====================================================
                    */
                    var amount = voucher_amount + account_bank_statement_line_amount;
                    if(AccountVoucher.length > 0 || AccountBankStatementLine.length > 0){
                        var currency = self.getResCurrency(index.currency[0]).shift();
                        var total = 0;
                        if(index.currency[0]){
                            total = accounting.formatMoney(amount_currency,'',CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator) + '    (' + accounting.formatMoney(amount,'',currency.decimal_places, currency.thousands_separator, currency.decimal_separator) + ')';
                        }else{
                            total = accounting.formatMoney(amount_currency,'',CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                        }
                        info.push({
                            journal : index.complete_name,
                            amount_total : total,
                            amount : amount_currency,

                            decimal_places : CurrencyBase.decimal_places,
                            thousands_separator: CurrencyBase.thousands_separator,
                            decimal_separator: CurrencyBase.decimal_separator,
                        });
                        info.sort(function(a, b) {
                            return b.amount - a.amount
                        });
                    }
                });
                var total_amount = _.reduce(_.map(info, function (map) {
                    return map.amount
                }), function (meno,num) {
                    return meno + num
                }, 0);
                if(total_amount > 0){
                    data.push({
                        store: item.name,
                        amount_total: accounting.formatMoney(total_amount, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                        amount: total_amount,
                        /*==============================
                            TOTAL FOOTER CONFIGURATION
                        ==============================*/
                        decimal_places : CurrencyBase.decimal_places,
                        thousands_separator: CurrencyBase.thousands_separator,
                        decimal_separator: CurrencyBase.decimal_separator,
                        /*
                        ================================
                            DATA
                        ================================
                        */
                        info: info,
                    });
                }
            });
            data.sort(function(a, b) {
                return b.amount - a.amount
            });
            self.content = data;
            if(ResStore.length > 1){
                self.loadTable(data,ResStore.length);
            }
            else{
                self.loadTable(info,ResStore.length);
            }

            self.CallCharts(data,CurrencyBase);
        },

        /*
        ======================================================================
            LLAMAR LOS GRAFICOS
        ======================================================================
        */
        CallCharts: function(data,CurrencyBase){
            var self = this;
            /*
            ================================================
            GRAFICO DE BARRAS
            ================================================
            */
            var BarChart = new reporting.ReportChartWidget(self);
            var item;
            var label = [];
            var body = [];
            for (var i = 0; i < data.length; i++) {
                if (data[i]){
                    item = data[i];
                }else{
                    item = {};
                    item.store = "N/A";
                    item.amount = 0;
                }
                label.push(item.store.trim());
                body.push(item.amount);
            }
            BarChart.BuildBarChart(data,CurrencyBase,label,body);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable, ResStore){
            var self = this;
            var table = self.$el.find('#table');
            table.bootstrapTable('destroy');

            if(ResStore > 1){
              table.bootstrapTable({
                  data: rowsTable,
                  columns: [{
                      field: 'store',
                      title: 'Sucursal',
                      footerFormatter: 'Totales',
                  },
                  {
                      field: 'amount_total',
                      title: 'Total',
                      footerFormatter: totalFormatter,
                  }],

                  detailView: true,
                  detailFormatter:detailFormatter,
              });
              self.$el.find('.chart-container').css('display','block');
            }
            else{
              table.bootstrapTable({
                  data: rowsTable,
                  columns: [{
                      field: 'journal',
                      title: 'Método de pago',
                      footerFormatter: 'Totales',
                  },
                  {
                      field: 'amount_total',
                      title: 'Total',
                      footerFormatter: totalFormatter,
                  }],
              });
              self.$el.find('.chart-container').css('display','none');
            }
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                ResCompany = self.ResCompany[0];
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            var amount = totalFormatter(row);

            row.push({
                store: 'Totales',
                journal: 'Totales',
                amount_total: amount,
            })

            if (action === 'pdf') {
                var data = _.map(column, function (val){ return val.field});
                _.each(_.map(column,function(val){
                    return val}), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Resumen de Ingresos';
                var pdf_type = '';
                var pdf_name = 'resumen_ingresos_';
                var pdf_columnStyles =  {
                    store:{halign:'left'},
                    amount_total:{columnWidth: 50, halign:'right'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new reporting.ReportPdfWidget(self);

                var ResStore = self.getResStore();
                if(ResStore.length > 1){
                    pdf.drawWithDetails(
                        _.flatten(getColumns),
                        row,
                        ResCompany,
                        pdf_title,
                        pdf_type,
                        pdf_name,
                        pdf_columnStyles,
                        amount,
                    );
                }
                else{
                  pdf.drawPDF(
                      _.flatten(getColumns),
                      row,
                      ResCompany,
                      pdf_title,
                      pdf_type,
                      pdf_name,
                      pdf_columnStyles,
                      filter,
                  );
                }
            }
        },
        getFilter: function(){
          var self = this;
          var company = self.$el.find('#current-company').val();
          var store = self.$el.find('#current-store').val();
          var period = self.$el.find('#current-period').val();
          var date = self.$el.find('#current-date').val();
          var desde = self.$el.find('#from').val();
          var hasta = self.$el.find('#to').val();

          var filter = [];

          if(company && company != 9999999){
            var ResCompany = _.filter(self.ResCompany, function(item){
              return item.id == company;
            });
            filter.push({
              title:'Empresa',
              value: ResCompany[0].name,
            });
          }

          if(store && store != 9999999){
            var ResStore =  _.filter(self.ResStore,function (item) {
                return item.id == store;
            });

            filter.push({
                title: 'Sucursal',
                value:  ResStore[0].name,
            });

          }

          if(period && period != 9999999){

            var AccountPeriod =  _.filter(self.AccountPeriod,function (item) {
                return item.id == period;
            });
            filter.push({
                 title: 'Periodo',
                 value:  AccountPeriod[0].name,
               });
          }

          if(date && date != 9999999){
            moment.locale('es', {
              months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
            });

            if(date == 'range'){
              filter.push({
                  title: 'Fecha',
                  value:  desde +' al '+hasta,
              });

            }
            else {
              if(date == 'today'){
                  var fecha = moment().format('DD/MM/YYYY');
              }

              if(date == 'yesterday'){
                  var fecha = moment().add(-1,'days').format('DD/MM/YYYY');
              }
              if(date == 'currentMonth'){
                  var fecha = moment().format('MMMM/YYYY');
              }
              if(date == 'lastMonth'){
                  var fecha = moment().add(-1,'months').format('MMMM/YYYY');
              }

              filter.push({
                  title: 'Fecha',
                  value:  fecha,
              });
            }
          }
          return filter;
        },
    });
}
