function report_product_list(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportProductListWidget = reporting.Base.extend({
        template: 'ReportProductList',
        rowsData :[],
        content :[],
        modules: ['product_brand'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'click-row.bs.table #table' : 'clickAnalysisDetail',
            'change #current-company' : 'updateSelections',
            'change #current-attribute' : 'updateAttributeSelections',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },
        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model
            });
        },

        clickAnalysisDetail: function(e, row, $element,field){
            if (field == 'name'){
                this.do_action({
                    name:"Producto",
                    type: 'ir.actions.act_window',
                    res_model: "product.product",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }
            e.stopImmediatePropagation();
        },

        fetchInitial: function () {
            var self = this;
            self.fecthIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResUser();
            }).then(function (ResUser) {
                self.ResUser = ResUser;
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchProductCategory();
            }).then(function(ProductCategory){
                self.ProductCategory = ProductCategory;
                self.$el.find('#current-category').append('<option value="9999999">Todas las categorias</option>');
                _.each(ProductCategory,function(item){
                    self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.complete_name + '</option>');
                });
                return self.fetchProductBrand();
            }).then(function(ProductBrand){
                self.ProductBrand = ProductBrand;
                if(ProductBrand.length > 0){
                    self.$el.find('#current-brand').append('<option value="9999999">Todas las marcas</option>');
                    _.each(ProductBrand,function(item){
                        self.$el.find('#current-brand').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.brand').css('display','none');
                }
                return self.fetchProductAttribute();
            }).then(function(ProductAttribute){
                self.ProductAttribute = ProductAttribute;
                if(ProductAttribute.length > 0){
                    self.$el.find('#current-attribute').append('<option value="9999999">Todos los atributos</option>');
                    _.each(ProductAttribute,function(item){
                        self.$el.find('#current-attribute').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute').css('display','none');
                }
                return self.fetchProductAttributeValue();
            }).then(function(ProductAttributeValue){
                self.ProductAttributeValue = ProductAttributeValue;
                if(ProductAttributeValue.length > 0){
                    self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                    _.each(ProductAttributeValue,function(item){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute-value').css('display','none');
                }
                return self.fetchProductPriceList();
            }).then(function(ProductPriceList){
                self.ProductPriceList = ProductPriceList;
                if(ProductPriceList.length > 0){
                  var sale = _.filter(ProductPriceList,function (item) {
                      return item.type == 'sale';
                  });
                  var purchase = _.filter(ProductPriceList,function (item) {
                      return item.type == 'purchase';
                  });
                  self.$el.find('#current-sale-price').append('<option value="9999999">Precio Base</option>');
                  _.each(sale,function(item){
                      self.$el.find('#current-sale-price').append('<option value="' + item.id + '">' + item.name + '</option>');
                  });

                  self.$el.find('#current-purchase-price').append('<option value="9999999">Precio Base</option>');
                  _.each(purchase,function(item){
                      self.$el.find('#current-purchase-price').append('<option value="' + item.id + '">' + item.name + '</option>');
                  });
               }else{
                  self.$el.find('.salePrice').css('display','none');
                  self.$el.find('.buyPrice').css('display','none');
              }
                return self.fetchPricelistVersion();
            }).then(function(PricelistVersion){
                self.PricelistVersion = PricelistVersion;
                return self.fetchPricelistVersionItem();
            }).then(function(PricelistVersionItem){
                self.PricelistVersionItem = PricelistVersionItem;
                return self.fetchResCurrency();
            }).then(function(ResCurrency){
                self.ResCurrency = ResCurrency;
                return self.fetchProductTemplate();
            }).then(function(ProductTemplate){
                self.ProductTemplate = ProductTemplate;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchProductProduct().then(function(ProductProduct) {
                return ProductProduct;
            }).then(function (ProductProduct) {
                self.ProductProduct = ProductProduct;
                return self.BuildTable();
            });
        },

        /*=====================================================================
            IR MODULE
        =====================================================================*/
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },



        /*=====================================================================
            USER
        =====================================================================*/
        fetchResUser: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','store_id'];
            var domain = [['id','=',self.session.uid]];
            var ResUser = new model.web.Model('res.users');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*=====================================================================
            PRICE LIST
        =====================================================================*/
        fetchProductPriceList: function() {
            var self = this;
            var domain = [];
            var ProductProduct = new model.web.Model('product.pricelist');
            return ProductProduct.call('getProductPriceList',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*=====================================================================
            PRICE LIST VERSION
        =====================================================================*/
        fetchPricelistVersion: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','listprice_id','items_id','date_start','date_end'];
            var domain = [['active','=',true]];
            var ResUser = new model.web.Model('product.pricelist.version');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*=====================================================================
            PRICE LIST VERSION ITEMS
        =====================================================================*/
        fetchPricelistVersionItem: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','product_id','categ_id','min_quantity','product_tmpl_id','sequence','base','price_discount','price_surcharge','price_round','price_min_margin','price_max_margin'];
            var ResUser = new model.web.Model('product.pricelist.item');
            ResUser.query(fields).filter().all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES COMPANY
        ====================================================================*/
        fetchResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id','name','currency_id','logo'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES STORE
        ====================================================================*/
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        /*====================================================================
            PRODUCT TEMPLATE
        ====================================================================*/
        fetchProductTemplate: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','product_variant_ids','store_id'];
            var domain =[
              ['active','=', true],
              ['sale_ok','=',true]];

            var ProductTemplate = new model.web.Model('product.template');
            ProductTemplate.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            PRODUCT CATEGORY
        ====================================================================*/
        fetchProductCategory : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','parent_id','complete_name'];
            var ProductCategory = new model.web.Model('product.category');
            ProductCategory.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },
        /*====================================================================
            PRODUCT BRAND
        ====================================================================*/
        fetchProductBrand : function(){
            var self = this;
            var defer = $.Deferred();
            var modules = self.checkModel('product_brand');
            if (modules.length > 0){
                var fields = ['id','name'];
                var ProductBrand = new model.web.Model('product.brand');
                ProductBrand.query(fields).filter().all().then(function(results) {
                    defer.resolve(results);
                });
                return defer;
            }else{
                var ProductBrand = [];
                return ProductBrand;
            }
        },

        /*====================================================================
            PRODUCT ATTRIBUTE
        ====================================================================*/
        fetchProductAttribute : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name'];
            var ProductAttribute = new model.web.Model('product.attribute');
            ProductAttribute.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            PRODUCT ATTRIBUTE VALUE
        ====================================================================*/
        fetchProductAttributeValue : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','attribute_id'];
            var ProductAttributeValue = new model.web.Model('product.attribute.value');
            ProductAttributeValue.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },


        /*====================================================================
            RES CURRENCY
        ====================================================================*/
        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES PARTNER
        ====================================================================*/
        fetchProductProduct: function() {
            var self = this;
            var categ_ids = [];
            var templates_ids =[];
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var state = self.$el.find('#current-state').val();
            var state1 = self.$el.find('#current-state1').val();
            var type = self.$el.find('#current-type').val();
            var category = self.$el.find('#current-category').val();
            var brand = self.$el.find('#current-brand').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var domain = [
                ['active', '=', true],
                ['sale_ok','=',true],
            ];

            if(company && company != 9999999){
                domain.push(['company_id','=',parseInt(company)]);
            }

            if(store && store != 9999999){
                _.map(_.filter(self.ProductTemplate, function (item) {
                  return item.store_id[0] == store;
                }), function(map){

                    if(map.product_variant_ids.length > 1){
                        _.each(map.product_variant_ids, function(each){
                            templates_ids.push(each);
                        });
                    }else{
                        templates_ids.push(map.product_variant_ids[0]);
                    }
                });
                domain.push(['id','in', templates_ids]);
            }

            if(state && state != 9999999){
              if(state == 'available'){
                domain.push(['qty_available','>',0]);
              }
              if(state == 'unavailable'){
                domain.push(['qty_available','<=',0]);
              }
            }

            if(type && type != 9999999){
              domain.push(['type','=',type]);
            }

            if(category){
              // Nivel 0, nivel 1
              var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                  return item.id == category || item.parent_id[0] == category;
              }), function(map){
                  return map.id;
              });

              // Nivel 0, nivel 1, nivel 2
              var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                  return _.contains(category_ids, item.parent_id[0]) || item.id == category;
              }), function(map){
                  return map.id;
              });

              // Nivel 0, nivel 1, nivel 2, nivel 3
              var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                  return _.contains(category_children_ids, item.parent_id[0]) || item.id == category;
              }), function(map){
                  return map.id;
              }) ;

              // Nivel 0, nivel 1, nivel 2, nivel 3, nivel 4
              categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                  return _.contains(category_grandchildren_ids, item.parent_id[0]) || item.id == category;
              }), function(map){
                  return map.id;
              });
            }

            if(category && category != 9999999){
              domain.push(['categ_id','in',categ_ids]);
            }

            if(brand && brand != 9999999){
              domain.push(['product_brand_id','=',parseInt(brand)]);
            }

            var attribute_ids = _.map(_.filter(self.ProductAttribute,function (item) {
              return item.id == attribute;
            }), function(map){
              return map.id;
           });

           var attribute_value_ids = _.map(_.filter(self.ProductAttributeValue,function (item) {
              return item.id == attribute_value;
            }), function(map){
              return map.id;
           });

           if(attribute && attribute != 9999999){
             domain.push(['attribute_line_ids.attribute_id', 'in', attribute_ids]);
           }

           if(attribute_value && attribute_value != 9999999){
             domain.push(['attribute_value_ids', 'in', attribute_value_ids]);
           }

           var ProductProduct = new model.web.Model('product.product');
           return ProductProduct.call('getProductProduct',[domain], {
                context: new model.web.CompoundContext()
           });
        },


        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });

            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateAttributeSelections: function () {
            var self = this;
            var attribute = self.$el.find('#current-attribute').val();
            if(attribute != 9999999){
                /*=============================
                    ATTRIBUTE VALUE SELECTION
                =============================*/
                var attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    if(parseFloat(attribute) == item.attribute_id[0]){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*=============================
                    ATTRIBUTE VALUE SELECTION
                =============================*/
                var attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },




        /*====================================================================
            GET RES COMPANY
        ====================================================================*/
        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },

        /*====================================================================
            GET RES CURRENCY BASE
        ====================================================================*/
        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },

        getPricelistVersion: function(id){
          var self = this;
          return _.filter(self.PricelistVersion,function (item) {
              return item.id === id;
          })
        },

        getPricelistVersionItem: function(id){
          var self = this;
          var item= _.filter(self.PricelistVersionItem,function (item) {
              return item.id === id;

          })
            return item[0];
        },

        getProductSalePrice: function(product){
          var self = this;
          var r;
          var CurrencyBase;
          var today = moment().format('YYYY-MM-DD');
          var salePrice = self.$el.find('#current-sale-price').val();
          var company = self.$el.find('#current-company').val();

          if(company && company != 9999999){
              var ResCompany = self.getResCompany(company).shift();
              CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
          }else{
              CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
          }

          if(salePrice && salePrice != 9999999){
            var priceList= _.filter(self.ProductPriceList,function (item) {
              return item.id == salePrice;
            });

            var x = _.map(priceList, function(map){
              if(map.version_id.length > 0){
                _.each(map.version_id, function(v){
                  var version = self.getPricelistVersion(v);
                  var date_start = version.date_start;
                  var date_end = version.date_end;
                  r= _.filter(version, function(a){
                    return ((a.date_start == false) || (a.date_start <= today)) && ((a.date_end == false) || (a.date_end >= today));
                  });
                });

                var item=  _.map(r[0].items_id,function(i){
                  return self.getPricelistVersionItem(i);
                });

                var items =[];
                var items2 = [];
                _.each(item, function(index){
                  if(index.product_tmpl_id && index.product_tmpl_id[0] == product.product_tmpl_id){
                    items.push(index);
                  }
                  if(index.sequence > 1) {
                    items2.push(index);
                  }
                });

                if(items.length > 0){
                  return items[0];
                }
                else{
                  if(items2.length > 0){
                    items2.sort(function(a, b) {
                      return a.sequence - b.sequence
                    });
                    return items2[0];
                  }
                }
              }
            });
            if(CurrencyBase.id == priceList[0].currency_id.id){
              return product.lst_price*(1+x[0].price_discount)+x[0].price_surcharge;
            }
            else {
              return (product.lst_price*priceList[0].currency_id.rate_silent)*(1+x[0].price_discount)+x[0].price_surcharge;
            }
          }
          else{
            return product.lst_price;
          }
        },

        getProductBuyPrice: function(product){
          var self = this;
          var r;
          var CurrencyBase;
          var today = moment().format('YYYY-MM-DD');
          var company = self.$el.find('#current-company').val();
          var purchasePrice = self.$el.find('#current-purchase-price').val();

          if(company && company != 9999999){
              var ResCompany = self.getResCompany(company).shift();
              CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
          }else{
              CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
          }

          if(purchasePrice && purchasePrice != 9999999){
            var priceList = _.filter(self.ProductPriceList,function (item) {
              return item.id == purchasePrice;
            });

            var x = _.map(priceList, function(map){
              if(map.version_id.length > 0){
                _.each(map.version_id, function(v){
                  var version = self.getPricelistVersion(v);
                  var date_start = version.date_start;
                  var date_end = version.date_end;
                  r= _.filter(version, function(a){
                    return ((a.date_start == false) || (a.date_start <= today)) && ((a.date_end == false) || (a.date_end >= today));
                  });
                });

                var item=  _.map(r[0].items_id,function(i){
                  return self.getPricelistVersionItem(i);
                });
                var items =[];
                var items2 = [];
                _.each(item, function(index){
                  if(index.product_tmpl_id && index.product_tmpl_id[0] == product.product_tmpl_id){
                    items.push(index);
                  }
                  if(index.sequence > 1) {
                    items2.push(index);
                  }
                });

                if(items.length > 0){
                  return items[0];
                }
                else{
                  if(items2.length > 0){
                    items2.sort(function(a, b) {
                      return a.sequence - b.sequence
                    });
                    return items2[0];
                  }
                }
              }
            });

            if(CurrencyBase.id == priceList[0].currency_id.id){
              return product.standard_price*(1+x[0].price_discount)+x[0].price_surcharge;
            }
            else {
              return (product.standard_price*priceList[0].currency_id.rate_silent)*(1+x[0].price_discount)+x[0].price_surcharge;
            }
          }
          else{
            return product.standard_price;
          }
        },


        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
            var self = this;
            var data = [];
            var company = $('#current-company').val();
            var purchasePrice = self.$el.find('#current-purchase-price').val();
            var salePrice = self.$el.find('#current-sale-price').val();

            if(company && company != 9999999){
                var ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }

            if(purchasePrice && purchasePrice != 9999999){
                var priceList =  _.filter(self.ProductPriceList,function (item) {
                    return item.id == purchasePrice;
                });
                var CurrencyBasePurchase = self.getResCurrency(priceList[0].currency_id.id).shift();
            }else{
                var CurrencyBasePurchase = CurrencyBase;
            }
            if(salePrice && salePrice != 9999999){
                var priceList = _.filter(self.ProductPriceList,function (item) {
                  return item.id == salePrice;
                });
                var CurrencyBaseSale = self.getResCurrency(priceList[0].currency_id.id).shift();
            }else{
                var CurrencyBaseSale = CurrencyBase;
            }

            var ProductProduct = self.ProductProduct;

            _.each(ProductProduct, function(item){
              var salePrice = self.getProductSalePrice(item);
              var purchasePrice = self.getProductBuyPrice(item);
              // var auxminimo = 0;
              //
              //   if(item.qty_available>item.minimo_quantity){
              //       auxminimo = 1;
              //   }
              //   else{
              //       auxminimo = 0;
              //   }

                if(item.image_medium){
                  var src='data:image/png;base64,'+ item.image_medium;
                }
                else{
                  var src="/web/static/src/img/placeholder.png";
                }

              var brand = _.map(_.filter(self.ProductBrand,function (a) {
                  return a.id == item.product_brand_id;
              }), function(map){
                  return map.name;
              });

                data.push({
                    id : item.id,
                    image_medium : src,
                    name : item.display_name,
                    brand: brand,
                    default_code : self.valorNull(item.default_code),
                    categ_id : item.categ_id.complete_name,
                    standard_price : accounting.formatMoney(purchasePrice, '', CurrencyBasePurchase.decimal_places, CurrencyBasePurchase.thousands_separator, CurrencyBasePurchase.decimal_separator),
                    lst_price : accounting.formatMoney(salePrice, '', CurrencyBaseSale.decimal_places, CurrencyBaseSale.thousands_separator, CurrencyBaseSale.decimal_separator),
                    qty_available : accounting.formatNumber(item.qty_available,'',CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                    // minimo_quantity : accounting.formatNumber(item.minimo_quantity,'',CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                    standard_price_no_format: purchasePrice,
                    lst_price_no_formart: salePrice,
                    qty_no_formart: item.qty_available,
                    // minimo_quantity_no_formart: item.minimo_qty,
                    // minimo_quantity_aux: auxminimo,


                    /*==============================
                        TOTAL FOOTER CONFIGURATION
                    ==============================*/
                    decimal_places : CurrencyBase.decimal_places,
                    thousands_separator: CurrencyBase.thousands_separator,
                    decimal_separator: CurrencyBase.decimal_separator,

                    decimal_places_sale : CurrencyBaseSale.decimal_places,
                    thousands_separator_sale: CurrencyBaseSale.thousands_separator,
                    decimal_separator_sale: CurrencyBaseSale.decimal_separator,
                    symbol_sale: CurrencyBaseSale.symbol,

                    decimal_places_purchase : CurrencyBasePurchase.decimal_places,
                    thousands_separator_purchase: CurrencyBasePurchase.thousands_separator,
                    decimal_separator_purchase: CurrencyBasePurchase.decimal_separator,
                    symbol_purchase: CurrencyBasePurchase.symbol,
                });
            });

            self.content = data;

            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();

            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                ResCompany = self.ResCompany[0];
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }

            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            if (action === 'pdf') {
              var data = _.map(column, function (val){ return val.field});
              _.each(_.map(column,function(val){
                  return val
              }), function(item){
                  if(item.field != 'image_medium'){
                      getColumns.push([{
                          title: item.title,
                          dataKey: item.field
                      }]);
                  }
              });

              var standard_price = purchaseTotalFormatter(row);
              var lst_price = saleTotalFormatter(row);
              var qty_available = qtyTotalFormatter(row);

              row.push({
                  default_code : 'Totales',
                  standard_price : standard_price,
                  lst_price: lst_price,
                  qty_available: qty_available,
              });

                var pdf_title = 'Lista de Productos.';
                var pdf_type = 'l';
                var pdf_name = 'lista_de_productos_';

                var pdf_columnStyles = {
                  name :{halign:'left'},
                  brand :{columnWidth: 25, halign:'center'},
                  default_code :{columnWidth: 25,halign:'left'},
                  categ_id :{halign:'left'},
                  standard_price :{columnWidth: 25, halign:'right'},
                  lst_price :{columnWidth: 25, halign:'right'},
                  qty_available :{columnWidth: 20, halign:'center'},
                  // minimo_quantity :{columnWidth: 20, halign:'center'},
                }

                var filter = self.getFilter();
                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter,
                );
            }
        },

        getFilter: function(){
          var self = this;
          var company = self.$el.find('#current-company').val();
          var store = self.$el.find('#current-store').val();
          var state = self.$el.find('#current-state').val();
          // var state1 = self.$el.find('#current-state1').val();
          var type = self.$el.find('#current-type').val();
          var salePrice = self.$el.find('#current-sale-price').val();
          var purchasePrice = self.$el.find('#current-purchase-price').val();
          var brand = self.$el.find('#current-brand').val();
          var category = self.$el.find('#current-category').val();
          var attribute = self.$el.find('#current-attribute').val();
          var attribute_value = self.$el.find('#current-attribute-value').val();
          var filter = [];

          if(company && company != 9999999){
            var ResCompany = _.filter(self.ResCompany, function(item){
              return item.id == company;
            });
            filter.push({
              title:'Empresa',
              value: ResCompany[0].name,
            });
          }

          if(store && store != 9999999){
            var ResStore =  _.filter(self.ResStore,function (item) {
                return item.id == store;
            });

            filter.push({
                 title: 'Sucursal',
                 value:  ResStore[0].name,
               });

          }
          if(state && state != 9999999){
            filter.push({
                 title: 'Estado',
                 value:  $("#current-state option:selected").text(),
               });
          }

          // if(state1 && state1 != 9999999){
          //   filter.push({
          //        title: 'Stock Minimo',
          //        value:  $("#current-state1 option:selected").text(),
          //      });
          // }

          if(type && type != 9999999){
            filter.push({
                 title: 'Tipo',
                 value:  $("#current-type option:selected").text(),
               });
          }

          if(salePrice && salePrice != 9999999){
            var sale =  _.filter(self.ProductPriceList,function (item) {
                return item.id == salePrice;
            });
            filter.push({
                 title: 'Precio de Venta',
                 value: sale[0].name,
               });
          }

          if(purchasePrice && purchasePrice != 9999999){
            var purchase =  _.filter(self.ProductPriceList,function (item) {
                return item.id == purchasePrice;
            });
            filter.push({
                 title: 'Precio de Compra',
                 value: purchase[0].name,
               });
          }

          if(brand && brand != 9999999){
            var brand =  _.filter(self.ProductBrand,function (item) {
                return item.id == brand;
            });
            filter.push({
                 title: 'Marca',
                 value: brand[0].name,
               });
          }

          if(category && category != 9999999){
            var categ =  _.filter(self.ProductCategory,function (item) {
                return item.id == category;
            });
            filter.push({
                 title: 'Categoría',
                 value: categ[0].name,
               });
          }

          if(attribute && attribute != 9999999){
            var attr =  _.filter(self.ProductAttribute,function (item) {
                return item.id == attribute;
            });
            filter.push({
                 title: 'Atributo',
                 value: attr[0].name,
               });
          }

          if(attribute_value && attribute_value != 9999999){
            var attr_value =  _.filter(self.ProductAttributeValue,function (item) {
                return item.id == attribute_value;
            });
            filter.push({
                 title: 'Valor de Atributo',
                 value: attr_value[0].name,
               });
          }
          return filter;
        }
    });
}
