function report_purchase_journal(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportPurchaseJournalWidget = reporting.Base.extend({
        template: 'ReportPurchaseJournal',
        rowsData :[],
        content :[],
        modules: ['purchase'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'click-row.bs.table #table' : 'clickAnalysisDetail',
            'change #current-company' : 'updateSelections',
            'change #current-store' : 'updateJournalSelections',
            'change #current-period' : 'updatePeriodSelections',
            'change #current-date' : 'ShowDateRange',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model
            });
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }

        },

        clickAnalysisDetail: function(e, row, $element,field){

            e.stopImmediatePropagation();
        },

        fetchInitial: function () {
            var self = this;
            // console.log(self);
            self.fecthIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResUser;
            }).then(function (ResUser) {
                self.ResUser = ResUser;
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                self.fecthCheckType();
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                if(AccountJournal.length > 1){
                    self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                    _.each(AccountJournal,function(item){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.journal').css('display','none');
                }
                return self.fetchAccountPeriod();
            }).then(function(AccountPeriod){
                self.AccountPeriod = AccountPeriod;
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fetchResCurrency();
            }).then(function(ResCurrency){
                self.ResCurrency = ResCurrency;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchAccountInvoice().then(function(AccountInvoice) {
                return AccountInvoice;
            }).then(function (AccountInvoice) {
                self.AccountInvoice = AccountInvoice;
                return self.BuildTable();
            });
        },

        /*=====================================================================
            IR MODULE
        =====================================================================*/
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },


        /*=====================================================================
            Check type
        =====================================================================*/
        fecthCheckType: function(){
            var self = this;
            var modules = self.checkModel('purchase');
            if(modules.length == 0){
                self.$el.find('.type').css('display','none');
            }
        },

        /*=====================================================================
            USER
        =====================================================================*/
        fetchResUser: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','store_id'];
            // var domain = [['id','=',self.session.uid]];
            var ResUser = new model.web.Model('res.users');
            ResUser.query(fields).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*=====================================================================
            ACCOUNT PERIOD
        =====================================================================*/
        fetchAccountPeriod: function () {
            var self = this;
            var defer = $.Deferred();
            var domain = [['special','=',false]];
            var field =['id', 'name', 'date_start','date_stop','company_id'];
            var AccountPeriod = new model.web.Model('account.period');

            AccountPeriod.query(field).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES STORE
        ====================================================================*/
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            ACCOUNT JOURNAL
        ====================================================================*/
        fetchAccountJournal: function(){
            var self = this;
            var defer = $.Deferred();
            var company = $('#current-company').val();
            var store = $('#current-store').val();
            var domain = [['active','=',true],['type','=','purchase']];
            if(company && company != 9999999){
                domain.push(['company_id','=',parseFloat(company)]);
            }
            if(store && store != 9999999){
                domain.push(['store_ids','=',parseFloat(store)]);
            }
            var field = ['id', 'name','store_ids'];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            ACCOUNT INVOICE
        ====================================================================*/
        fetchAccountInvoice: function () {
            var self = this
            // console.log(self);
            var store = self.$el.find('#current-store').val();
            var period = self.$el.find('#current-period').val();
            var state = self.$el.find('#current-state').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var journal = self.$el.find('#current-journal').val();
            if(store && store != 9999999){
                var journal_ids = _.map(_.filter(self.AccountJournal,function (item) {
                    return item.store_ids == store;
                }), function(map){
                    return map.id;
                });
            }else{
                var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                    return item.id;
                }));
            }
            var domain = [
                ['state', 'in',['open','paid']],
                ['type', '=', 'in_invoice'],
                ['journal_id','in',journal_ids],
            ];
            if(period != 9999999){
                domain.push(['period_id','=',parseInt(period)]);
            }

            if(journal && journal != 9999999){
                domain.push(['journal_id','=',parseInt(journal)]);
            }

            if(state != 9999999){
                domain.push(['state','=',state]);
            }

            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        var date = desde.split('/')
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        domain.push(['date_invoice','>=',date]);
                    }
                    if(hasta){
                        var date = hasta.split('/')
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        domain.push(['date_invoice','<=',date]);
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    domain.push(['date_invoice','=',today]);
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    domain.push(['date_invoice','=',yesterday]);
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    domain.push(['date_invoice','like',currentMonth]);
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    domain.push(['date_invoice','like',lastMonth]);
                }
            }
            var AccountInvoice = new model.web.Model('account.invoice');
            return AccountInvoice.call('getAccountInvoice',[domain], {
                context: new model.web.CompoundContext()
            });
        },


        /*====================================================================
            RES COMPANY
        ====================================================================*/
        fetchResCompany: function(){
            var self = this;
            var domain = [[1,'=',1]];
            var ResCompany = new model.web.Model('res.company');
            return ResCompany.call('getResCompany',[domain],{
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            RES CURRENCY
        ====================================================================*/
        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },
        updateJournalSelections: function () {
            var self = this;
            var store = self.$el.find('#current-store').val();
            if(store != 9999999){
                /*=============================
                    ACCOUNT JOURNAL SELECTION
                =============================*/
                var journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    if(parseFloat(store) == item.store_ids){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*=============================
                    ACCOUNT JOURNAL SELECTION
                =============================*/
                var journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },
        updatePeriodSelections: function () {
            var self = this;
            var period = self.$el.find('#current-period').val();
            if(period != 9999999){
                self.$el.find('#current-date').val(9999999);
                self.$el.find('#current-date').prop('disabled','disabled');
                self.$el.find('.datepicker').css('display','none');
            }else{
                self.$el.find('#current-date').prop('disabled',false);
            }
        },

        /*====================================================================
            GET RES COMPANY
        ====================================================================*/
        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },

        /*====================================================================
            GET RES CURRENCY BASE
        ====================================================================*/
        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },

        /*============================
            ACCOUNT DATA BY MONTH
        ============================*/
        getContent:function(mes) {
            var self = this;
            return _.flatten(_.filter(self.content,function (inv) {
                return moment(inv.date).format('YYYY-MM') === moment(mes).format('YYYY-MM');
            }));
        },

        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
            var self = this;
            var data = [];
            var company = $('#current-company').val();

            if(company && company != 9999999){
                var ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }

            /*
            ==========================================
                ACCOUNT INVOICE
            ==========================================
            */
            // if(type == 'purchase'){
                var AccountInvoice = self.AccountInvoice;
                _.each(AccountInvoice, function(item){
                    // console.log(item);
                    var gravada = 0;
                    var impuesto = 0;
                    var exenta = 0;
                    if(item.amount_tax_currency == 0){
                        exenta = item.amount_total_currency;
                    }else{
                        gravada = item.amount_total_currency - item.amount_tax_currency;
                    }
                    data.push({
                        /*=======================
                            IDS
                        =======================*/
                        id : item.id,
                        /*=======================
                            INFO
                        =======================*/
                        number : item.number,
                        supplier_invoice_number: self.valorNull(item.supplier_invoice_number),
                        date_invoice : moment(item.date_invoice).format('DD/MM/YYYY'),
                        date : item.date_invoice,
                        partner_id : self.valorNull(item.partner_id[1]),
                        partner_ruc : self.valorNull(item.partner_id[2]),
                        gravada_total : accounting.formatMoney(gravada, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                        percetage_total : '',
                        tax_total : accounting.formatMoney(item.amount_tax_currency, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                        exenta_total : accounting.formatMoney(exenta, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                        ret_iva_total : 0,
                        ret_renta_total : 0,
                        amount_total : accounting.formatMoney(item.amount_total_currency, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                        /*=======================
                            VALORES SIN FORMATEAR
                        =======================*/
                        gravada : gravada,
                        tax : item.amount_tax_currency,
                        exenta : exenta,
                        ret_iva : 0,
                        ret_renta : 0,
                        amount : item.amount_total_currency,
                        /*==============================
                            TOTAL FOOTER CONFIGURATION
                        ==============================*/
                        decimal_places : CurrencyBase.decimal_places,
                        thousands_separator: CurrencyBase.thousands_separator,
                        decimal_separator: CurrencyBase.decimal_separator,
                    });
                });
            // }
            // data.sort(function(a,b){
            //     // return new Date(a.date) - new Date(b.date);
            //     return new Date(b.date) - new Date(a.date);
            // });

            data.sort(function (a, b) {
                if (a.date > b.date) {
                    return 1;
                }
                if (a.date < b.date) {
                    return -1;
                }
                return 0;
            });

            self.content = data;
            self.loadTable(data);

            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            var date = $('#current-company').val();
            var period = $('#current-period').val();
            var pdf_type = $('#current-pdf-type').val();
            var desde = $('#from').val();
            var hasta = $('#to').val();
            if(period && period != 9999999){
                var data = _.filter(self.AccountPeriod,function (inv) {
                    return inv.id == parseInt(period);
                });
                desde = moment(data[0].date_start).format('DD/MM/YYYY');
                hasta = moment(data[0].date_stop).format('DD/MM/YYYY');
            }

            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                ResCompany = self.ResCompany[0];
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            var gravada = _.reduce(_.map(row, function (map) {
                return map.gravada;
            }), function (memo, num) {
                return memo + num;
            });

            var tax = _.reduce(_.map(row, function (map) {
                return map.tax;
            }), function (memo, num) {
                return memo + num;
            });

            var exenta = _.reduce(_.map(row, function (map) {
                return map.exenta;
            }), function (memo, num) {
                return memo + num;
            });

            var ret_iva = _.reduce(_.map(row, function (map) {
                return map.ret_iva;
            }), function (memo, num) {
                return memo + num;
            });

            var ret_renta = _.reduce(_.map(row, function (map) {
                return map.ret_renta;
            }), function (memo, num) {
                return memo + num;
            });

            var total = _.reduce(_.map(row, function (map) {
                return map.amount;
            }), function (memo, num) {
                return memo + num;
            });

            row.push({
                number : 'Items: ',
                supplier_invoice_number: row.length,
                date_invoice : ' ',
                partner_id : 'TOTALES: ',
                partner_ruc : ' ',
                gravada_total : accounting.formatMoney(gravada, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                tax_total : accounting.formatMoney(tax, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                exenta_total : accounting.formatMoney(exenta, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                ret_iva_total : accounting.formatMoney(ret_iva, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                ret_renta_total : accounting.formatMoney(ret_renta, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                amount_total : accounting.formatMoney(total, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
            });

            if (action === 'pdf') {
                var data = _.map(column, function (val){ return val.field});
                _.each(_.map(column,function(val){
                    return val}), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Libro de Compras.';
                var pdf_name = 'libro_de_compras_';
                if(pdf_type == 1){
                    pdf_type = 'l';
                    var pdf_columnStyles = {
                        number :{columnWidth: 27, halign:'center'},
                        supplier_invoice_number: {columnWidth: 24, halign:'center'},
                        date_invoice :{columnWidth: 24, halign:'center'},
                        partner_id :{columnWidth: 52, halign:'left'},
                        partner_ruc : {columnWidth: 18, halign:'left'},
                        gravada_total : {columnWidth: 24.2, halign:'right'},
                        percetage_total : {columnWidth: 8.9, halign:'right'},
                        tax_total : {columnWidth: 24, halign:'right'},
                        exenta_total : {columnWidth: 21, halign:'right'},
                        ret_iva_total : {columnWidth: 18, halign:'right'},
                        ret_renta_total : {columnWidth: 20, halign:'right'},
                        amount_total : {columnWidth: 24, halign:'right'},
                    };
                }else{
                    pdf_type = '';
                    var pdf_columnStyles = {
                        number :{columnWidth: 25, halign:'center'},
                        supplier_invoice_number: {columnWidth: 24, halign:'center'},
                        date_invoice :{columnWidth: 16, halign:'center'},
                        partner_id :{columnWidth: 35, halign:'left'},
                        partner_ruc : {columnWidth: 16.8, halign:'left'},
                        gravada_total : {columnWidth: 18, halign:'right'},
                        percetage_total : {columnWidth: 4, halign:'right'},
                        tax_total : {columnWidth: 15, halign:'right'},
                        exenta_total : {columnWidth: 16, halign:'right'},
                        ret_iva_total : {columnWidth: 7, halign:'right'},
                        ret_renta_total : {columnWidth: 7, halign:'right'},
                        amount_total : {columnWidth: 18, halign:'right'},
                    };
                }

                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawPurchaseJournalPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    desde,
                    hasta,
                );
            }
        },
    });
}
