function report_sale_ranking_product(reporting) {
    "use strict";

    var model = openerp;

    reporting.ReportSaleRankingProductWidget = reporting.Base.extend({
        template: 'ReportSaleRankingProduct',
        rowsData: [],
        content: [],
        modules: ['product_brand', 'point_of_sale'],

        events: {
            'click #generate': 'fetchGenerate',
            'change #current-company': 'updateSelections',
            'change #current-attribute': 'updateAttributeSelections',
            'change #current-store': 'updateJournalSelections',
            'change #current-date': 'ShowDateRange',
            'click .build-chart':'CallChart',
            'click .print-report':'clickOnAction',
        },

        init: function(parent) {
            this._super(parent);
        },

        start: function() {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull: function(dato) {
            var valor = "";
            if (dato) {
                valor = dato;
            }
            return valor;
        },

        checkModule: function(module) {
            var self = this;
            return _.filter(self.session.module_list, function(item) {
                return item == module;
            });
        },

        ShowDateRange: function() {
            var self = this;
            var date = self.$el.find('#current-date').val();
            if (date == 'range') {
                self.$el.find('.datepicker').css('display', 'block');
            }
            if (date != 'range') {
                self.$el.find('.datepicker').css('display', 'none');
            }
        },

        fetchInitial: function () {
            var self = this;
            self.fetchIntialSQL().then(function (IntialSQL) {
                return IntialSQL;
            }).then(function(IntialSQL) {
                /*
                =================================
                    RES COMPANY
                =================================
                */
                self.ResCompany = IntialSQL.companies;
                self.CompanyLogo = IntialSQL.logo;
                if(self.ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(self.ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                /*
                =================================
                    RES STORE
                =================================
                */
                self.ResStore = IntialSQL.stores;
                if(self.ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(self.ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                /*
                =================================
                    ACCOUNT JOURNAL
                =================================
                */
                self.AccountJournal = IntialSQL.journals;
                if(self.AccountJournal.length > 1){
                    self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                    _.each(self.AccountJournal,function(item){
                        if(item.type == 'sale'){
                            self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                        }
                    });
                }else{
                    self.$el.find('.journal').css('display','none');
                }
                /*
                =================================
                    PRODUCT CATEGORY
                =================================
                */
                self.ProductCategory = IntialSQL.categories;
                if(self.ProductCategory.length > 1){
                    self.$el.find('#current-category').append('<option value="9999999">Todos las Categorias</option>');
                    _.each(self.ProductCategory,function(item){
                        self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }
                self.ProductBrand = IntialSQL.brands;
                if(self.ProductBrand.length > 1){
                    self.$el.find('#current-brand').append('<option value="9999999">Todas las Marcas</option>');
                    _.each(self.ProductBrand,function(item){
                        self.$el.find('#current-brand').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.brand').css('display','none');
                }
                self.ProductAttribute = IntialSQL.attributes;
                if(self.ProductAttribute.length > 1){
                    self.$el.find('#current-attribute').append('<option value="9999999">Todas los atributos</option>');
                    _.each(self.ProductAttribute,function(item){
                        self.$el.find('#current-attribute').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute').css('display','none');
                }
                self.ProductAttributeValue = IntialSQL.attribute_values;
                if(self.ProductAttributeValue.length > 1){
                    self.$el.find('#current-attribute-value').append('<option value="9999999">Todas los valores de atributos</option>');
                    _.each(self.ProductAttributeValue,function(item){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute-value').css('display','none');
                }
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchCheckType();
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },


        fetchGenerate: function () {
            var self = this;
            self.$el.find('.chart-container').css('display', 'none');
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchDataSQL().then(function(DataSQL) {
                return DataSQL;
            }).then(function (DataSQL) {
                self.AccountInvoiceLine = DataSQL.invoice_lines;
                self.PosOrderLine = DataSQL.order_lines;
                self.ProductProduct = DataSQL.products;
                return self.BuildTable();
            });
        },

        fetchIntialSQL: function() {
            var self = this;
            var data = $.get('/report-filter-data');
            return data;
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/report-sale-product-ranking');
            return data;
        },

        fetchCheckType: function() {
            var self = this;
            var modules = self.checkModule('point_of_sale');
            if (modules.length == 0) {
                self.$el.find('.type').css('display', 'none');
            }
        },

        updateSelections: function () {
            var self = this;
            var store;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateAttributeSelections: function () {
            var self = this;
            var attribute_value;
            var attribute = self.$el.find('#current-attribute').val();
            if(attribute != 9999999){
                attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    if(parseFloat(attribute) == item.attribute_id){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateJournalSelections: function () {
            var self = this;
            var journal;
            var store = self.$el.find('#current-store').val();
            if(store != 9999999){
                journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    if(parseFloat(store) == item.store_id){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        getPosOrderLine:function() {
            var self = this;
            var content = self.PosOrderLine;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var type = self.$el.find('#current-type').val();
            var journal = self.$el.find('#current-journal').val();
            var category = self.$el.find('#current-category').val();
            var brand = self.$el.find('#current-brand').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.company_id == company;
                }));
            }
            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.store_id == store;
                }));
            }
            if(type && type != 9999999){
                if(type == 'sale'){
                    content = [];
                }
            }
            if(journal && journal != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.journal_id == journal;
                }));
            }
            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                            utc = moment(utc._d).format('YYYY-MM-DD');
                            return moment(utc).format('YYYY-MM-DD') >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                            utc = moment(utc._d).format('YYYY-MM-DD');
                            return moment(utc).format('YYYY-MM-DD') <= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM-DD') === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM-DD') === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM') === currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM') === lastMonth;
                    }));
                }
            }
            if(category && category != 9999999){
                var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return item.id == category || item.parent_id == category;
                }), function(map){
                    return map.id;
                });
                var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_children_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_grandchildren_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                content = _.flatten(_.filter(content,function (inv) {
                    return _.contains(categ_ids, inv.categ_id);
                }));
            }
            if(brand && brand != 9999999){
                content = _.filter(content,function (item) {
                    return item.product_brand_id == parseInt(brand);
                });
            }
            if(attribute && attribute != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_ids, parseInt(attribute));
                });
            }
            if(attribute_value && attribute_value != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_value_ids, parseInt(attribute_value));
                });
            }
            return content;
        },

        getAccountInvoiceLine:function() {
            var self = this;
            var content = self.AccountInvoiceLine;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var type = self.$el.find('#current-type').val();
            var journal = self.$el.find('#current-journal').val();
            var category = self.$el.find('#current-category').val();
            var brand = self.$el.find('#current-brand').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.company_id == company;
                }));
            }
            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.store_id == store;
                }));
            }
            if(type && type != 9999999){
                if(type == 'tpv'){
                    content = [];
                }
            }
            if(journal && journal != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.journal_id == journal;
                }));
            }
            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.date).format('YYYY-MM-DD') >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.date).format('YYYY-MM-DD') <= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM-DD') === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM-DD') === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') === currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') === lastMonth;
                    }));
                }
            }
            if(category && category != 9999999){
                var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return item.id == category || item.parent_id == category;
                }), function(map){
                    return map.id;
                });
                var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_children_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_grandchildren_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                content = _.flatten(_.filter(content,function (inv) {
                    return _.contains(categ_ids, inv.categ_id);
                }));
            }
            if(brand && brand != 9999999){
                content = _.filter(content,function (item) {
                    return item.product_brand_id == parseInt(brand);
                });
            }
            if(attribute && attribute != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_ids, parseInt(attribute));
                });
            }
            if(attribute_value && attribute_value != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_value_ids, parseInt(attribute_value));
                });
            }
            return content;
        },

        getAccountInvoiceLineByProduct:function(product_id,type) {
            var self = this;
            return  _.filter(self.AccountInvoiceLine,function (item) {
                return item.product_id == product_id && item.type == type;
            });
        },

        getPosOrderLineByProduct:function(product_id) {
            var self = this;
            return  _.filter(self.PosOrderLine,function (item) {
                return item.product_id == product_id;
            });
        },

        BuildTable: function() {
            var self = this;
            var data = [];
            var display_name;
            var modules = self.checkModule('product_brand');
            var CurrencyBase = self.ResCompany[0].currency_id;
            self.AccountInvoiceLine = self.getAccountInvoiceLine();
            self.PosOrderLine = self.getPosOrderLine();
            var ProductProduct = self.ProductProduct;
            _.each(ProductProduct, function(item) {
                if(item.attribute_values[0] == null){
                    display_name = item.product_name;
                }else{
                    display_name = item.product_name + ' (' + _.uniq(item.attribute_values) + ')';
                }
                if(modules.length > 0){
                    if(item.product_brand_id != null){
                        display_name = display_name + ' ( ' + item.brand_name + ')';
                    }
                }
                /*
                    INVOICE
                */
                var AccountInvoiceLine = self.getAccountInvoiceLineByProduct(item.product_id,'out_invoice');
                var InvoiceLineQuantity = _.reduce(_.map(AccountInvoiceLine, function(map) {
                    return map.quantity;
                }), function(meno, num) {
                    return meno + num;
                }, 0);
                var InvoiceLineAmount = _.reduce(_.map(AccountInvoiceLine, function(map) {
                    return map.subtotal + map.tax;
                }), function(meno, num) {
                    return meno + num;
                }, 0);
                /*
                    INVOICE REFUND
                */
                var AccountInvoiceLineRefund = self.getAccountInvoiceLineByProduct(item.product_id,'out_refund');
                var InvoiceLineRefundQuantity = _.reduce(_.map(AccountInvoiceLineRefund, function(map) {
                    return map.quantity;
                }), function(meno, num) {
                    return meno + num;
                }, 0);
                var InvoiceLineRefundAmount = _.reduce(_.map(AccountInvoiceLineRefund, function(map) {
                    return map.subtotal + map.tax;
                }), function(meno, num) {
                    return meno + num;
                }, 0);
                /*
                    POSORDER
                */
                var PosOrderLine = self.getPosOrderLineByProduct(item.product_id);
                var PosOrderQuantity = _.reduce(_.map(PosOrderLine, function(map) {
                    return map.quantity;
                }), function(meno, num) {
                    return meno + num;
                }, 0);
                var PosOrderAmount = _.reduce(_.map(PosOrderLine, function(map) {
                    return map.subtotal + map.tax;
                }), function(meno, num) {
                    return meno + num;
                }, 0);

                var quantity = PosOrderQuantity + InvoiceLineQuantity - InvoiceLineRefundQuantity;
                var amount = PosOrderAmount + InvoiceLineAmount - InvoiceLineRefundAmount;

                if(quantity != 0 || amount != 0){
                    if(amount < 0 && quantity > 0){
                        quantity = quantity * -1;
                    }
                    data.push({
                        id:item.product_id,
                        name:display_name,
                        brand_name: item.brand_name,
                        attribute_value_ids:item.attribute_value_ids,
                        quantity:accounting.formatNumber(quantity,2,'.',','),
                        amount:accounting.formatMoney(amount,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                        /*
                            NO FORMAT
                        */
                        quantity_no_format:quantity,
                        amount_no_format:amount,
                        /*
                            FOOTER
                        */
                        decimal_places: CurrencyBase.decimal_places,
                        thousands_separator: CurrencyBase.thousands_separator,
                        decimal_separator: CurrencyBase.decimal_separator,
                    });
                }
            });

            data.sort(function(a, b) {
                return b.amount_no_format - a.amount_no_format;
            });
            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display', 'block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },
        /*
        ======================================================================
            LLAMAR LOS GRAFICOS
        ======================================================================
        */
        CallChart: function() {
            var self = this;
            var data = self.content;
            var i,item,num,amount_total;
            var rank = 10;
            var label = [];
            var body = [];
            var CurrencyBase = self.ResCompany[0].currency_id;
            /*
            ================================================
                BAR CHART
            ================================================
            */
            var BarChart = new reporting.ReportChartWidget(self);
            for (i = 0; i < rank; i++) {
                if (data[i]) {
                    item = data[i];
                }else {
                    item = {};
                    item.name = "N/A";
                    item.amount_no_format = 0;
                }
                label.push(item.name.trim());
                body.push(item.amount_no_format);
            }
            BarChart.BuildBarChart(data, CurrencyBase, label, body);
            /*
            ================================================
                PIE CHART
            ================================================
            */
            var PieChart = new reporting.ReportChartWidget(self);
            label = [];
            body = [];
            amount_total = _.reduce(_.map(data, function(map) {
                return map.amount_no_format;
            }), function(meno, num) {
                return meno + num;
            }, 0);
            for (i = 0; i < rank; i++) {
                if (data[i]) {
                    item = data[i];
                } else {
                    item = {};
                    item.name = "N/A";
                    item.amount_no_format = 0;
                }
                label.push(item.name.trim());
                body.push((item.amount_no_format / amount_total) * 100);
            }
            num = 0;
            for (i = 9; i < data.length; i++) {
                num += data[i].amount_no_format;
            }
            if (num > 0) {
                label.push('Otros Productos');
                body.push((num / amount_total) * 100);
            }
            PieChart.BuildPieChart(data, CurrencyBase, label, body);
            /*
            ================================================
                DOUGHNUT CHART
            ================================================
            */
            var DoughnutChart = new reporting.ReportChartWidget(self);
            var info = [];
            var content = [];
            var ProductAttributeValue = self.ProductAttributeValue;
            if (ProductAttributeValue.length > 0) {
                _.each(ProductAttributeValue, function(item) {
                    content = _.filter(data, function(index) {
                        return _.contains(index.attribute_value_ids, item.id);
                    });

                    var amount = _.reduce(_.map(content, function(map) {
                        return map.amount_no_format;
                    }), function(meno, num) {
                        return meno + num;
                    }, 0);
                    if (amount > 0) {
                        info.push({
                            name: item.attribute_name + ' - ' + item.name + ' - ' + accounting.formatMoney(amount, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            amount_no_format: amount
                        });
                    }
                });
                info.sort(function(a, b) {
                    return b.amount_no_format - a.amount_no_format;
                });

                rank = 9;
                label = [];
                body = [];

                amount_total = _.reduce(_.map(data, function(map) {
                    return map.amount_no_format;
                }), function(meno, num) {
                  return meno + num;
                }, 0);

                for (i = 0; i < rank; i++) {
                    if (info[i]) {
                        item = info[i];
                    } else {
                        item = {};
                        item.name = "N/A";
                        item.amount_no_format = 0;
                    }
                    label.push(item.name.trim());
                    body.push((item.amount_no_format / amount_total) * 100);
                }
                num = 0;
                for (i = 9; i < info.length; i++) {
                    num += info[i].amount_no_format;
                }
                if (num > 0) {
                    label.push('Otros Atributos');
                    body.push((num / amount_total) * 100);
                }
                DoughnutChart.BuildDoughnutChart(data, CurrencyBase, label, body);
                self.$el.find('.doughnut-chart').css('display', 'block');
            }
            self.$el.find('.chart-container').css('display', 'block');
        },
        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable: function(rowsTable) {
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function(e) {
            var self = this;
            var ResCompany;
            var CurrencyBase;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = _.flatten(_.filter(self.CompanyLogo,function (inv) {
                    return inv.id == company;
                }));
                ResCompany = ResCompany[0];
                CurrencyBase = ResCompany[0].currency_id;
            }else{
                ResCompany = self.CompanyLogo[0];
                CurrencyBase = self.ResCompany[0].currency_id;
            }
            var getColumns = [];
            var rows = [];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');
            var quantity = QuantityFooter(row);
            var amount = TotalFooter(row);
            row.push({
                name:'Totales',
                brand_name: brand_name,
                quantity:quantity,
                amount:amount,
            });

            if (action === 'pdf') {
                var data = _.map(column, function (val){
                    return val.field;
                });
                _.each(_.map(column,function(val){
                    return val;
                }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Ranking de productos (+Vendidos).';
                var pdf_type = '';
                var pdf_name = 'ranking_productos_';
                var pdf_columnStyles = {
                    name: {halign: 'left'},
                    brand_name: {columnWidth: 15, halign: 'left'},
                    quantity: {columnWidth: 30, halign: 'right'},
                    amount: {columnWidth: 30, halign: 'right'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
                );
            }
        },
        getFilter: function() {
            var self = this;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var type = self.$el.find('#current-type').val();
            var category = self.$el.find('#current-category').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var filter = [];
            if (company && company != 9999999) {
                var ResCompany = _.filter(self.ResCompany, function(item) {
                    return item.id == company;
                });
                filter.push({
                    title: 'Empresa',
                    value: ResCompany[0].name,
                });
            }
            if (store && store != 9999999) {
                var ResStore = _.filter(self.ResStore, function(item) {
                    return item.id == store;
                });
                filter.push({
                    title: 'Sucursal',
                    value: ResStore[0].name,
                });
            }
            if (type && type != 9999999) {
                filter.push({
                    title: 'Tipo de Venta',
                    value: $("#current-type option:selected").text(),
                });
            }
            if (category && category != 9999999) {
                var categ = _.filter(self.ProductCategory, function(item) {
                    return item.id == category;
                });
                filter.push({
                    title: 'Categoría',
                    value: categ[0].name,
                });
            }
            if (date && date != 9999999) {
                moment.locale('es', {
                    months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
                });
                if (date == 'range') {
                    filter.push({
                        title: 'Fecha',
                        value: desde + ' al ' + hasta,
                    });
                } else {
                    var fecha;
                    if (date == 'today') {
                        fecha = moment().format('DD/MM/YYYY');
                    }
                    if (date == 'yesterday') {
                        fecha = moment().add(-1, 'days').format('DD/MM/YYYY');
                    }
                    if (date == 'currentMonth') {
                        fecha = moment().format('MMMM/YYYY');
                    }
                    if (date == 'lastMonth') {
                        fecha = moment().add(-1, 'months').format('MMMM/YYYY');
                    }
                    filter.push({
                        title: 'Fecha',
                        value: fecha,
                    });
                }
            }
            return filter;
        },
    });
}
