function report_supplier_payment(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportSupplierPaymentWidget = reporting.Base.extend({
        template: 'ReportSupplierPayment',
        rowsData :[],
        content :[],
        modules: ['point_of_sale'],

        events:{
            'click #generate' : 'fetchGenerate',
            'change #current-company' : 'updateSelections',
            'change #current-store' : 'updateJournalSelections',
            'change #current-date' : 'ShowDateRange',
            'click .print-report':'clickOnAction',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model;
            });
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }
        },

        fetchInitial: function () {
            var self = this;
            self.fetchIntialSQL().then(function (IntialSQL) {
                return IntialSQL;
            }).then(function(IntialSQL) {
                /*
                =================================
                    RES COMPANY
                =================================
                */
                self.ResCompany = IntialSQL.companies;
                self.CompanyLogo = IntialSQL.logo;
                if(self.ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(self.ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                /*
                =================================
                    RES STORE
                =================================
                */
                self.ResStore = IntialSQL.stores;
                if(self.ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(self.ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                /*
                =================================
                    ACCOUNT JOURNAL
                =================================
                */
                self.AccountJournal = IntialSQL.journals;
                var journal = _.flatten(_.filter(self.AccountJournal,function (item) {
                    return item.type == 'cash' || item.type == 'bank';
                }));
                if(journal.length > 1){
                    self.$el.find('#current-journal').append('<option value="9999999">Todos los métodos de pago</option>');
                    _.each(journal,function(item){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.journal').css('display','none');
                }
                return self.fethIrModuleModule();
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fethCheckType();
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchDataSQL().then(function(DataSQL) {
                return DataSQL;
            }).then(function (DataSQL) {
                self.AccountVoucher = DataSQL.vouchers;
                self.AccountInvoice = DataSQL.invoices;
                return self.BuildTable();
            });
        },

        fetchIntialSQL: function() {
            var self = this;
            var data = $.get('/report-filter-data');
            return data;
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/report-supplier-account-voucher');
            return data;
        },

        fethIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*=====================================================================
            Check type
        =====================================================================*/
        fethCheckType: function(){
            var self = this;
            var modules = self.checkModel('point_of_sale');
            if(modules.length == 0){
                self.$el.find('.type').css('display','none');
            }
        },

        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var store;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateJournalSelections: function () {
            var self = this;
            var journal;
            var AccountJournal = _.flatten(_.filter(self.AccountJournal,function (item) {
                return item.type == 'cash' || item.type == 'bank';
            }));
            var store = self.$el.find('#current-store').val();
            if(store != 9999999){
                self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todos los métodos de pago</option>');
                _.each(AccountJournal,function(item){
                    if(item.store_id == store){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todos los métodos de pago</option>');
                _.each(AccountJournal,function(item){
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        getAccountVoucher:function(number) {
            var self = this;
            var content = self.AccountVoucher;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var journal = self.$el.find('#current-journal').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();

            content = _.filter(content,function (item) {
                return item.reference == number;
            })

            if((store && store == 9999999)||(company && company == 9999999)){
                var store_ids = _.flatten(_.map(self.ResStore, function (item) {
                    return item.id;
                }));
                var company_ids = _.flatten(_.map(self.ResCompany, function (item) {
                    return item.id;
                }));
                content = _.flatten(_.filter(content,function (item) {
                    return _.contains(store_ids, item.store_id) && _.contains(company_ids, item.company_id);
                }));
            }

            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.company_id == company;
                }));
            }
            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.store_id == store;
                }));
            }
            if(journal && journal != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.journal_id == journal;
                }));
            }
            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.date).format('YYYY-MM-DD') >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.date).format('YYYY-MM-DD') <= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM-DD') === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM-DD') === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') === currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') === lastMonth;
                    }));
                }
            }
            return content;
        },

        BuildTable: function(){
            var self = this;

            var data = [];
            var residual = 0;
            var CurrencyBase = self.ResCompany[0].currency_id;

              var AccountInvoice = self.AccountInvoice;

            _.each(AccountInvoice, function(each){
              var AccountVoucher = self.getAccountVoucher(each.number);
              _.each(AccountVoucher, function(item){

                var amount = item.amount_currency;
                if(item.currency_id != null){
                    amount = amount + '('  + item.amount + ')';
                }
                data.push({
                    id:item.id,
                    date:moment(item.date).format('DD/MM/YYYY'),
                    origin:item.origin,
                    name:item.name,
                    number:item.number,
                    partner_name:item.partner_name,
                    journal_name:item.journal_name,
                    reference:item.reference,
                    total:accounting.formatMoney(amount,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                    /*
                    =======================
                        NO FORMAT
                    =======================
                    */
                    date_no_format: moment(item.date).format('YYYY-MM-DD'),
                    total_no_format:item.amount_currency,
                    /*
                    =======================
                        FOOTER
                    =======================
                    */
                    decimal_places:CurrencyBase.decimal_places,
                    thousands_separator:CurrencyBase.thousands_separator,
                    decimal_separator:CurrencyBase.decimal_separator,
                });
              });
            });
            data.sort(function (a, b) {
                if (a.date_no_format > b.date_no_format) {
                    return -1;
                }
                if (a.date_no_format < b.date_no_format) {
                    return 1;
                }
                return 0;
            });
            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var CurrencyBase;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = _.flatten(_.filter(self.ResCompany,function (inv) {
                    return inv.id == company;
                }));
                ResCompany = CompanyLogo[0];
                CurrencyBase = ResCompany[0].currency_id;
            }else{
                ResCompany = self.CompanyLogo[0];
                CurrencyBase = self.ResCompany[0].currency_id;
            }
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');
            var total = TotalFooter(row);
            row.push({
                date:'Totales',
                total:total,
            });

            if (action === 'pdf') {
                var data = _.map(column, function (val){
                    return val.field;
                });
                _.each(_.map(column,function(val){
                    return val;
                }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Pagos de proveedores.';
                var pdf_type = '';
                var pdf_name = 'pagos_de_proveedores';
                var pdf_columnStyles = {
                    date:{columnWidth: 20, halign:'center'},
                    origin:{columnWidth: 'auto', halign:'left'},
                    name:{columnWidth: 'auto', halign:'center'},
                    number:{columnWidth: 40, halign:'left'},
                    reference:{columnWidth: 40, halign:'left'},
                    partner_name:{columnWidth: 'auto'},
                    journal_name:{columnWidth: 'auto'},
                    total:{columnWidth: 20, halign:'right'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
                );
            }
        },
        getFilter: function(){
            var self = this;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var state = self.$el.find('#current-state').val();
            var journal = self.$el.find('#current-journal').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var filter = [];
            if(company && company != 9999999){
                var ResCompany = _.filter(self.ResCompany, function(item){
                    return item.id == company;
                });
                filter.push({
                    title:'Empresa',
                    value: ResCompany[0].name,
                });
            }
            if(store && store != 9999999){
                var ResStore =  _.filter(self.ResStore,function (item) {
                        return item.id == store;
                });
                filter.push({
                    title: 'Sucursal',
                    value:  ResStore[0].name,
                });
            }
            if(journal && journal != 9999999){
                var AccountJournal =  _.filter(self.AccountJournal,function (item) {
                    return item.id == journal;
                });
                filter.push({
                   title: 'Método de pago',
                   value: AccountJournal[0].name,
                });
            }
            if(date && date != 9999999){
                moment.locale('es', {
                    months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
                });

                if(date == 'range'){
                    filter.push({
                        title: 'Fecha',
                        value:  desde +' al '+hasta,
                    });
                }else {
                    var fecha;
                    if(date == 'today'){
                        fecha = moment().format('DD/MM/YYYY');
                    }
                    if(date == 'yesterday'){
                        fecha = moment().add(-1,'days').format('DD/MM/YYYY');
                    }
                    if(date == 'currentMonth'){
                        fecha = moment().format('MMMM/YYYY');
                    }
                    if(date == 'lastMonth'){
                        fecha = moment().add(-1,'months').format('MMMM/YYYY');
                    }
                    filter.push({
                        title: 'Fecha',
                        value:  fecha,
                    });
                }
            }
            return filter;
        },
    });
}
