function report_supplier_ranking(reporting){
  "use strict";

  var model = openerp;

  reporting.ReportSupplierRankingWidget = reporting.Base.extend({
    template : 'ReportSupplierRanking',
    rowsData : [],
    content : [],
    modules : ['product_brand'],
    events : {
      'click #toolbar > button' : 'clickOnAction',
      'click #generate' : 'fetchGenerate',
      'click-row.bs.table #table' : 'clickAnalysisDetail',
      'change #current-date' : 'ShowDateRange',
      'change #current-period':'updatePeriodSelections',
      'change #current-store': 'updateUsers',
    },

    init : function(parent){
      this._super(parent);
    },

    start : function(){
      var date = new reporting.ReportDatePickerWidget(self);
      date.fecthFecha();
      this.fetchInitial();
    },

    valorNull : function(dato){
      var valor = "";
      if (dato){
        valor = dato;
      }
      return valor;
    },

    checkModel : function(model){
      var self = this;
      return _.filter(self.IrModuleModule, function(item){
        return item.name == model;
      });
    },

    ShowDateRange : function(){
        var self = this;
        var date = self.$el.find('#current-date').val();
        if(date == 'range'){
            self.$el.find('.datepicker').css('display','block');
        }
        if(date != 'range'){
            self.$el.find('.datepicker').css('display','none');
        }

    },

    clickAnalysisDetail : function(e, row, $element, field){

      if(field == 'name'){
        this.do_action({
          name : 'Proveedor',
          type : 'ir.actions.act_window',
          res_model : 'res.partner',
          views : [[false,'form']],
          target  : 'new',
          domain : [['id','=',row.partner_id]],
          context : {},
          flags : {'form' : {'action_buttons' : false, 'options' : {'mode' : 'view'}}},
          res_id : row.partner_id,
        });
      }

      if(field == 'number'){
        this.do_action({
          name : 'Factura',
          type : 'ir.actions.act_window',
          res_model : 'account.invoice',
          views : [[false,'form']],
          target  : 'new',
          domain : [['id','=',row.invoice_id]],
          context : {},
          flags : {'form' : {'action_buttons' : false, 'options' : {'mode' : 'view'}}},
          res_id : row.invoice_id,
        });
      }
      e.stopImmediatePropagation();
    },

    fetchInitial: function () {
        var self = this;
        self.fetchIrModuleModule().then(function (IrModuleModule) {
            return IrModuleModule;
        }).then(function(IrModuleModule) {
            self.IrModuleModule = IrModuleModule;
            return self.fetchResUser();
        }).then(function (ResUser) {
            self.ResUser = ResUser;
            if(ResUser.length > 1){
                self.$el.find('#current-user').append('<option value="9999999">Todos los vendedores</option>');
                _.each(ResUser,function(item){
                    self.$el.find('#current-user').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }else{
                self.$el.find('.user').css('display','none');
            }
            return self.fetchResCompany();
        }).then(function(ResCompany){
            self.ResCompany = ResCompany;
            if(ResCompany.length > 1){
                self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                _.each(ResCompany,function(item){
                    self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }else{
                self.$el.find('.company').css('display','none');
            }
            return self.fetchResStore();
        }).then(function(ResStore){
            self.ResStore = ResStore;
            if(ResStore.length > 1){
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }else{
                self.$el.find('.store').css('display','none');
            }

            return self.fetchAccountPeriod();
        }).then(function(AccountPeriod){
            self.AccountPeriod = AccountPeriod;
            self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
            _.each(AccountPeriod,function(item){
              self.$el.find('#current-period').append('<option value="' +  item.id + '">' + item.name + '</option>');
            });
            return self.fetchProductCategory();
        }).then(function(ProductCategory){
            self.ProductCategory = ProductCategory;
            self.$el.find('#current-category').append('<option value="9999999">Todas las categorias</option>');
            _.each(ProductCategory,function(item){
                self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.complete_name + '</option>');
            });
            return self.fetchProductBrand();
        }).then(function(ProductBrand){
            self.ProductBrand = ProductBrand;
            if(ProductBrand.length > 0){
                self.$el.find('#current-brand').append('<option value="9999999">Todas las marcas</option>');
                _.each(ProductBrand,function(item){
                    self.$el.find('#current-brand').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }else{
                self.$el.find('.brand').css('display','none');
            }
            return self.fetchProductAttribute();
        }).then(function(ProductAttribute){
            self.ProductAttribute = ProductAttribute;
            if(ProductAttribute.length > 0){
                self.$el.find('#current-attribute').append('<option value="9999999">Todos los atributos</option>');
                _.each(ProductAttribute,function(item){
                    self.$el.find('#current-attribute').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }else{
                self.$el.find('.attribute').css('display','none');
            }
            return self.fetchProductAttributeValue();
        }).then(function(ProductAttributeValue){
            self.ProductAttributeValue = ProductAttributeValue;
            if(ProductAttributeValue.length > 0){
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(ProductAttributeValue,function(item){
                    self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }else{
                self.$el.find('.attribute-value').css('display','none');
            }
            return self.fetchProductTemplate();
        }).then(function(ProductTemplate){
            self.ProductTemplate = ProductTemplate;
            if(ProductTemplate.length > 0){
                self.$el.find('#current-product').append('<option value="9999999">Todos los productos</option>');
                _.each(ProductTemplate,function(item){
                    self.$el.find('#current-product').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }else{
                self.$el.find('.product').css('display','none');
            }
            return self.fetchResCurrency();
        }).then(function(ResCurrency){
            self.ResCurrency = ResCurrency;
            return self.fetchAccountJournal();
        }).then(function(AccountJournal){
            self.AccountJournal = AccountJournal;
        });
        self.$el.find('#generate').css('display','inline');
        return;
    },

    fetchGenerate: function () {
        var self = this;
        self.$el.find('.search-form').block({
            message: null,
            overlayCSS: {
                backgroundColor: '#FAFAFA'
            }
        });
        self.$el.find('.report-form').block({
            message: null,
            overlayCSS: {
                backgroundColor: '#FAFAFA'
            }
        });

        this.fetchAccountInvoice().then(function(AccountInvoice) {
            return AccountInvoice;
        }).then(function (AccountInvoice) {
            self.AccountInvoice = AccountInvoice;
            return self.fetchAccountInvoiceLine();
        }).then(function (AccountInvoiceLine){
            self.AccountInvoiceLine = AccountInvoiceLine;
            return self.fetchResPartner();
        }).then(function (ResPartner) {
            self.ResPartner = ResPartner;
            return self.BuildTable();
        });
    },

    /*=====================================================================
        IR MODULE
    =====================================================================*/
    fetchIrModuleModule: function(){
        var self = this;
        var defer = $.Deferred();
        var fields = ['name','id'];
        var domain=[['state','=','installed'],['name','in',self.modules]];
        var IrModuleModule = new model.web.Model('ir.module.module');
        IrModuleModule.query(fields).filter(domain).all().then(function(results){
            defer.resolve(results);
        })
        return defer;
    },

    /*=====================================================================
        USER
    =====================================================================*/
    fetchResUser: function() {
        var self = this;
        var defer = $.Deferred();
        var fields = ['id','name','store_id'];
        var ResUser = new model.web.Model('res.users');
        ResUser.query(fields).filter().all().then(function (results) {
            defer.resolve(results);
        });
        return defer;
    },

    /*====================================================================
        RES COMPANY
    ====================================================================*/
    fetchResCompany: function(){
        var self = this;
        var defer = $.Deferred();
        var currency = new model.web.Model('res.company');
        var field=['id','name','currency_id','logo'];
        currency.query(field).filter().all().then(function(results){
            defer.resolve(results);
        });
        return defer;
    },

    /*====================================================================
        ACCOUNT JOURNAL
    ====================================================================*/
    fetchAccountJournal: function(){
        var self = this;
        var domain = [['active','=',true],['type','=','purchase']];
        var AccountJournal = new model.web.Model('account.journal');
        return AccountJournal.call('getAccountJournal',[domain], {
            context: new model.web.CompoundContext()
        });
    },

    /*====================================================================
        RES STORE
    ====================================================================*/
    fetchResStore: function(){
        var self = this;
        var defer = $.Deferred();
        var field = ['id','name','company_id'];
        var ResStore = new model.web.Model('res.store');
        ResStore.query(field).all().then(function(results){
            defer.resolve(results);
        });
        return defer;
    },

    /*=====================================================================
        ACCOUNT PERIOD
    =====================================================================*/
    fetchAccountPeriod: function () {
        var self = this;
        var defer = $.Deferred();
        var domain = [['special','=',false]];
        var field =['id', 'name', 'date_start','date_stop','company_id'];
        var AccountPeriod = new model.web.Model('account.period');
        AccountPeriod.query(field).filter(domain).all().then(function (results) {
            defer.resolve(results);
        });
        return defer;
    },

    /*====================================================================
        PRODUCT TEMPLATE
    ====================================================================*/
    fetchProductTemplate: function(){
        var self = this;
        var defer = $.Deferred();
        var field = ['id','name','product_variant_ids','store_id'];
        var domain = [
          ['active','=', true],
          ['purchase_ok','=',true]];
        var ProductTemplate = new model.web.Model('product.template');
        ProductTemplate.query(field).filter(domain).all().then(function(results){
            defer.resolve(results);
        });
        return defer;
    },

    /*====================================================================
        PRODUCT CATEGORY
    ====================================================================*/
    fetchProductCategory : function(){
        var self = this;
        var defer = $.Deferred();
        var fields = ['id','name','parent_id','complete_name'];
        var ProductCategory = new model.web.Model('product.category');
        ProductCategory.query(fields).filter().all().then(function(results) {
            defer.resolve(results);
        });
        return defer;
    },

    /*====================================================================
        PRODUCT BRAND
    ====================================================================*/
    fetchProductBrand : function(){
        var self = this;
        var defer = $.Deferred();
        var modules = self.checkModel('product_brand');
        if (modules.length > 0){
            var fields = ['id','name'];
            var ProductBrand = new model.web.Model('product.brand');
            ProductBrand.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        }else{
            var ProductBrand = [];
            return ProductBrand;
        }
    },

    /*====================================================================
        PRODUCT ATTRIBUTE
    ====================================================================*/
    fetchProductAttribute : function(){
        var self = this;
        var defer = $.Deferred();
        var fields = ['id','name'];
        var ProductAttribute = new model.web.Model('product.attribute');
        ProductAttribute.query(fields).filter().all().then(function(results) {
            defer.resolve(results);
        });
        return defer;
    },

    /*====================================================================
        PRODUCT ATTRIBUTE VALUE
    ====================================================================*/
    fetchProductAttributeValue : function(){
        var self = this;
        var defer = $.Deferred();
        var fields = ['id','name','attribute_id'];
        var ProductAttributeValue = new model.web.Model('product.attribute.value');
        ProductAttributeValue.query(fields).filter().all().then(function(results) {
            defer.resolve(results);
        });
        return defer;
    },

    /*====================================================================
        RES CURRENCY
    ====================================================================*/
    fetchResCurrency : function(){
        var self = this;
        var defer = $.Deferred();
        var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
        var domain = [['active', '=', true]];
        var ResCurrency = new model.web.Model('res.currency');
        ResCurrency.query(fields).filter(domain).all().then(function(results) {
            defer.resolve(results);
        });
        return defer;
    },

    /*====================================================================
        ACCOUNT INVOICE
    ====================================================================*/
    fetchAccountInvoice: function () {
        var self = this;
        var user = self.$el.find('#current-user').val();
        var store = self.$el.find('#current-store').val();
        var period = self.$el.find('#current-period').val();
        var company = self.$el.find('#current-company').val();
        var date = self.$el.find('#current-date').val();
        var desde = self.$el.find('#from').val();
        var hasta = self.$el.find('#to').val();

        if(store && store != 9999999){
            var journal_ids = _.map(_.filter(self.AccountJournal,function (item) {
                return item.store_ids[0] == store;
            }), function(map){
                return map.id;
            });
        }else{
            var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                return item.id;
            }));
        }

        var domain = [
            ['state', 'in',['open','paid']],
            ['type', '=', 'in_invoice'],
            ['journal_id','in',journal_ids],
        ];

        if(company && company != 9999999){
            domain.push(['company_id','=',parseInt(company)]);
        }

        if(user && user != 9999999){
            domain.push(['user_id','=',parseInt(user)]);
        }

        if(period && period != 9999999){
            domain.push(['period_id','=',parseInt(period)]);
        }

        if(date && date != 9999999){

            if(desde){
                var date = desde.split('/')
                date = (date[2]+"-"+date[1]+"-"+date[0]);
                domain.push(['date_invoice','>=',date]);
            }

            if(hasta){
                var date = hasta.split('/')
                date = (date[2]+"-"+date[1]+"-"+date[0]);
                domain.push(['date_invoice','<=',date]);
            }

            if(date == 'today'){
                var today = moment().format('YYYY-MM-DD');
                domain.push(['date_invoice','=',today]);
            }

            if(date == 'yesterday'){
                var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                domain.push(['date_invoice','=',yesterday]);
            }

            if(date == 'currentMonth'){
                var currentMonth = moment().format('YYYY-MM');
                domain.push(['date_invoice','like',currentMonth]);
            }

            if(date == 'lastMonth'){
                var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                domain.push(['date_invoice','like',lastMonth]);
            }
        }

        var AccountInvoice = new model.web.Model('account.invoice');
        return AccountInvoice.call('getAccountInvoice',[domain], {
            context: new model.web.CompoundContext()
        });
    },

    /*====================================================================
        ACCOUNT INVOICE LINE
    ====================================================================*/
    fetchAccountInvoiceLine: function () {
      var self = this;
      var domain = [];
      var product_ids =[];
      var categ_ids = [];
      var templates_ids = [];
      var brand = self.$el.find('#current-brand').val();
      var product = self.$el.find('#current-product').val();
      var category = self.$el.find('#current-category').val();
      var invoice_ids = _.flatten(_.map(self.AccountInvoice, function (item) {
          return item.id;
      }));
      var domain = [
          ['invoice_id','in',invoice_ids],
      ];

      if(product && product != 9999999){
        _.map(_.filter(self.ProductTemplate, function (item) {
          return item.id == product;
        }), function(map){
          if(map.product_variant_ids.length > 1){
            _.each(map.product_variant_ids, function(each){
              product_ids.push(each);
            });
          }
          else{
            product_ids.push(map.product_variant_ids[0]);
          }
        });
        domain.push(['product_id','in', product_ids]);
      }

      if(brand && brand != 9999999){
          domain.push(['product_id.product_brand_id','=',parseInt(brand)]);
      }

      /*
      =================================================
          OBTENER CATEGORIAS EN CASCADA
      =================================================
      */
      if(category){
          // Nivel 0, nivel 1
          var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
              return item.id == category || item.parent_id[0] == category;
          }), function(map){
              return map.id;
          });

          // Nivel 0, nivel 1, nivel 2
          var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
              return _.contains(category_ids, item.parent_id[0]) || item.id == category;
          }), function(map){
              return map.id;
          });

          // Nivel 0, nivel 1, nivel 2, nivel 3
          var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
              return _.contains(category_children_ids, item.parent_id[0]) || item.id == category;
          }), function(map){
              return map.id;
          }) ;

          // Nivel 0, nivel 1, nivel 2, nivel 3, nivel 4
          categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
              return _.contains(category_grandchildren_ids, item.parent_id[0]) || item.id == category;
          }), function(map){
              return map.id;
          });
      };

      if(category && category != 9999999){
          domain.push(['product_id.categ_id','in',categ_ids]);
      }

      var AccountInvoiceLine = new model.web.Model('account.invoice.line');
      return AccountInvoiceLine.call('getAccountInvoiceLine',[domain], {
          context: new model.web.CompoundContext()
      });
    },

    /*====================================================================
        UPDATE SELECTIONS
    ====================================================================*/
    updateSelections: function () {
        var self = this;
        var company = self.$el.find('#current-company').val();
        if(company != 9999999){
            /*===================
                STORE SELECTION
            ===================*/
            var store = self.$el.find('#current-store').empty();
            self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
            _.each(self.ResStore,function(item){
                if(parseFloat(company) == item.company_id[0]){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                }
            });
            /*====================
                PERIOD SELECTION
            ====================*/
            var period = self.$el.find('#current-period').empty();
            self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
            _.each(self.AccountPeriod,function(item){
                if(parseFloat(company) == item.company_id[0]){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                }
            });
        }else{
            /*===================
                STORE SELECTION
            ===================*/
            var store = self.$el.find('#current-store').empty();
            self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
            _.each(self.ResStore,function(item){
                self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
            /*====================
                PERIOD SELECTION
            ====================*/
            var period = self.$el.find('#current-period').empty();
            self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
            _.each(self.AccountPeriod,function(item){
                self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
        }
    },
    updatePeriodSelections: function () {
        var self = this;
        var period = self.$el.find('#current-period').val();
        if(period != 9999999){
            self.$el.find('#current-date').val(9999999);
            self.$el.find('#current-date').prop('disabled','disabled');
            self.$el.find('.datepicker').css('display','none');
        }else{
            self.$el.find('#current-date').prop('disabled',false);
        }
    },

    updateUsers: function(){
      var self = this;
      var store = self.$el.find('#current-store').val();
      if(store != 9999999){
          var user = self.$el.find('#current-user').empty();
          self.$el.find('#current-user').append('<option value="9999999">Todos los vendedores</option>');
          _.each(self.ResUser,function(item){
              if(parseFloat(store) == item.store_id[0]){
                  self.$el.find('#current-user').append('<option value="' + item.id + '">' + item.name + '</option>');
              }
          });
      }else{
          var user = self.$el.find('#current-user').empty();
          self.$el.find('#current-user').append('<option value="9999999">Todos los vendedores</option>');
          _.each(self.ResUser,function(item){
              self.$el.find('#current-user').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
      }
    },

    /*====================================================================
        GET RES COMPANY
    ====================================================================*/
    getResCompany: function (id) {
        var self = this;
        return _.filter(self.ResCompany,function (item) {
            return item.id == id;
        })
    },

    /*====================================================================
        GET RES CURRENCY BASE
    ====================================================================*/
    getResCurrency: function (id) {
        var self = this;
        return _.filter(self.ResCurrency,function (item) {
            return item.id === id;
        })
    },

    /*====================================================================
        GET ACCOUNT INVOICE
    ====================================================================*/
    getAccountInvoice: function (id) {
        var self = this;
        return _.flatten(_.filter(self.AccountInvoice,function (item) {
            return item.partner_id[0] == id;
        }));
    },

    /*====================================================================
        GET ACCOUNT INVOICE LINE
    ====================================================================*/
    getAccountInvoiceLine: function (id) {
        var self = this;
        return _.flatten(_.filter(self.AccountInvoiceLine,function (item) {
            return item.invoice_id == id;
        }));
    },

    /*====================================================================
        RES PARTNER
    ====================================================================*/
    fetchResPartner : function () {
        var self = this;
        var partner_ids = _.flatten(_.map(self.AccountInvoice, function (item) {
            return item.partner_id[0];
        }));

        var domain = [
          ['id','in',partner_ids],
          ['active', '=', true],
          ['supplier', '=', true]];

        var ResPartner = new model.web.Model('res.partner');
        return ResPartner.call('getResPartner',[domain], {
            context: new model.web.CompoundContext()
        });
    },


    /*====================================================================
        BUILD
    ====================================================================*/
    BuildTable: function(){
        var self = this;
        var data = [];
        var company = $('#current-company').val();
        if(company && company != 9999999){
            var ResCompany = self.getResCompany(company).shift();
            var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
        }else{
            var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
        }

        var ResPartner = self.ResPartner;
        _.each(ResPartner, function(item){
            var suma_invoice = 0;
            var invoice_item = 0;
            var info = [];

            /*====================================================================
                RECORRER ACCOUNT INVOCE
            ====================================================================*/

            var AccountInvoice = self.getAccountInvoice(item.id);
            _.each(AccountInvoice,function(index) {
                var AccountInvoiceLine = self.getAccountInvoiceLine(index.id);
                _.each(AccountInvoiceLine,function(index2) {
                    invoice_item = invoice_item + index2.quantity;
                    suma_invoice = suma_invoice + (index2.price_unit*index2.quantity);
                });
                info.push({
                    /*=======================
                        IDS
                    =======================*/
                    invoice_id: index.id,
                    /*=======================
                        DATAS
                    =======================*/
                    number: index.number,
                    date: moment(index.date_invoice).format('DD/MM/YYYY'),
                    customer: index.partner_id[1],
                    amount: accounting.formatMoney(index.amount_total,'',CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                });
            });
            if(suma_invoice > 0){
                data.push({
                    //IDS
                    partner_id: item.id,
                    //DATAS
                    name : item.name,
                    suma_invoice : accounting.formatMoney(suma_invoice,'',CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    invoice_item : accounting.formatNumber(invoice_item,CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                    //VALORES SIN FORMATEAR
                    suma_invoice_not_format : suma_invoice,
                    invoice_item_no_format: invoice_item,
                    //TOTAL FOOTER CONFIGURATION
                    decimal_places : CurrencyBase.decimal_places,
                    thousands_separator: CurrencyBase.thousands_separator,
                    decimal_separator: CurrencyBase.decimal_separator,
                    info :info,
                });
            }
        });
        data.sort(function(a, b) {
            return b.suma_invoice_not_format - a.suma_invoice_not_format
        });
        self.content = data;
        self.CallCharts(data,CurrencyBase);
        self.loadTable(data);
    },

    /*
    ======================================================================
        LLAMAR LOS GRAFICOS
    ======================================================================
    */
    CallCharts: function(data,CurrencyBase){
        var self = this;
        /*
        ================================================
        GRAFICO DE BARRAS
        ================================================
        */
        var BarChart = new reporting.ReportChartWidget(self);
        var rank = 10;
        var item;
        var label = [];
        var body = [];
        for (var i = 0; i < rank; i++) {
            if (data[i]){
                item = data[i];
            }else{
                item = {};
                item.name = "N/A";
                item.suma_invoice_not_format = 0;
            }
            label.push(item.name.trim());
            body.push(item.suma_invoice_not_format);
        }
        BarChart.BuildBarChart(data,CurrencyBase,label,body);

        /*
        ================================================
        GRAFICO CIRCULAR
        ================================================
        */
        var PieChart = new reporting.ReportChartWidget(self);
        var rank = 9;
        var item;
        var label = [];
        var body = [];
        var amount_total = _.reduce(_.map(data, function (map) {
            return map.suma_invoice_not_format
        }), function (meno,num) {
            return meno + num
        }, 0);
        for (var i = 0; i < rank; i++) {
            if (data[i]){
                item = data[i];
            }else{
                item = {};
                item.name = "N/A";
                item.suma_invoice_not_format = 0;
            }
            label.push(item.name.trim());
            body.push((item.suma_invoice_not_format/amount_total)*100);
        }
        var num = 0;
        for (var i = 9; i < data.length; i++) {
            num += data[i].suma_invoice_not_format;
        }
        if(num > 0){
            label.push('Otros Productos');
            body.push((num/amount_total)*100);
        }
        PieChart.BuildPieChart(data,CurrencyBase,label,body);
        self.$el.find('.report-form').css('display','block');
        self.$el.find('.search-form').unblock();
        self.$el.find('.report-form').unblock();
    },



    /*====================================================================
        LOAD BOOTSTRAP TABLE
    ====================================================================*/

    loadTable: function(rowsTable) {
      var self = this;
      var data = [];
      self.rowsData = rowsTable;
      var table = this.$el.find('#table');

      table.bootstrapTable({
        data: rowsTable,
        detailView: true,
        onExpandRow: function(index, row, $detail) {
          $detail.html('<div class="panel panel-first-style"><div class="panel-heading panel-header-first-style">Facturas de Proveedor</div><table id="table2"></table></div>').find('table').bootstrapTable({
            columns: [{
                field: 'number',
                title: 'Factura',
                align: 'left',
                class: 'hover',
              },
              {
                field: 'date',
                title: 'Fecha',
                align: 'left',
              },
              {
                field: 'amount',
                title: 'Monto',
                align: 'right',
              },
            ],

            data: row.info,
          })
          $('#table2').removeClass('table-hover').addClass('table-no-bordered');
          $('thead').css('background', 'none');
        }
      })

      table.bootstrapTable('load', rowsTable);
    },

    /*====================================================================
        PRINT PDF
    ====================================================================*/
    clickOnAction: function (e) {
        var self = this;
        var ResCompany;
        var action = this.$el.find(e.target).val();
        var company = $('#current-company').val();
        if(company && company != 9999999){
            var ResCompany = self.getResCompany(company).shift();
            var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
        }else{
            ResCompany = self.ResCompany[0];
            var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
        }
        var getColumns=[];
        var rows=[];
        var table = this.$el.find("#table");
        var column = table.bootstrapTable('getVisibleColumns');
        var row = table.bootstrapTable('getData');

        var amount = totalAmountFormatter(row);
        var qty = totalQtyFormatter(row);

        row.push({
            name: 'Totales',
            suma_invoice: amount,
            invoice_item: qty,
        })

        if (action === 'pdf') {
            var data = _.map(column, function (val){ return val.field});
            _.each(_.map(column,function(val){
                return val}), function(item){
                getColumns.push([{
                    title: item.title,
                    dataKey: item.field
                }]);
            });
            /*
            ============================================================
                CONFIGURACION DEL PDF
            ============================================================
            */
            var pdf_title = 'Ranking de Proveedores';
            var pdf_type = '';
            var pdf_name = 'ranking_proveedores_';
            var pdf_columnStyles = {
                name :{columnWidth: 100, halign:'left'},
                invoice_item : {columnWidth: 45, halign:'right'},
                suma_invoice :{columnWidth: 45, halign:'right'},
            };
            /*
            ============================================================
                LLAMAR FUNCION DE IMPRESION
            ============================================================
            */
            var filter = self.getFilter();
            var pdf = new reporting.ReportPdfWidget(self);
            pdf.drawPDF(
                _.flatten(getColumns),
                row,
                ResCompany,
                pdf_title,
                pdf_type,
                pdf_name,
                pdf_columnStyles,
                filter,
            );
        }
    },
    getFilter: function(){
      var self = this;
      var company = self.$el.find('#current-company').val();
      var store = self.$el.find('#current-store').val();
      var user = self.$el.find('#current-user').val();
      var product = self.$el.find('#current-product').val();
      var brand = self.$el.find('#current-brand').val();
      var category = self.$el.find('#current-category').val();
      var period = self.$el.find('#current-period').val();
      var date = self.$el.find('#current-date').val();
      var desde = self.$el.find('#from').val();
      var hasta = self.$el.find('#to').val();
      var filter = [];

      if(company && company != 9999999){
        var ResCompany = _.filter(self.ResCompany, function(item){
          return item.id == company;
        });
        filter.push({
          title:'Empresa',
          value: ResCompany[0].name,
        });
      }

      if(store && store != 9999999){
        var ResStore =  _.filter(self.ResStore,function (item) {
            return item.id == store;
        });

        filter.push({
             title: 'Sucursal',
             value:  ResStore[0].name,
           });
      }

      if(user && user != 9999999){
        var ResUser =  _.filter(self.ResUser,function (item) {
            return item.id == user;
        });

        filter.push({
             title: 'Vendedor',
             value:  ResUser[0].name,
           });
      }

      if(product && product != 9999999){
        var Product =  _.filter(self.ProductTemplate,function (item) {
            return item.id == product;
        });
        filter.push({
             title: 'Producto',
             value:  Product[0].name,
           });
      }

      if(brand && brand != 9999999){
        var brand =  _.filter(self.ProductBrand,function (item) {
            return item.id == brand;
        });
        filter.push({
             title: 'Marca',
             value: brand[0].name,
           });
      }

      if(category && category != 9999999){
        var categ =  _.filter(self.ProductCategory,function (item) {
            return item.id == category;
        });
        filter.push({
             title: 'Categoría',
             value: categ[0].name,
           });
      }

      if(period && period != 9999999){

        var AccountPeriod =  _.filter(self.AccountPeriod,function (item) {
            return item.id == period;
        });
        filter.push({
             title: 'Periodo',
             value:  AccountPeriod[0].name,
           });
      }

      if(date && date != 9999999){
        moment.locale('es', {
          months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
        });

        if(date == 'range'){
          filter.push({
              title: 'Fecha',
              value:  desde +' al '+hasta,
          });

        }
        else {
          if(date == 'today'){
              var fecha = moment().format('DD/MM/YYYY');
          }

          if(date == 'yesterday'){
              var fecha = moment().add(-1,'days').format('DD/MM/YYYY');
          }
          if(date == 'currentMonth'){
              var fecha = moment().format('MMMM/YYYY');
          }
          if(date == 'lastMonth'){
              var fecha = moment().add(-1,'months').format('MMMM/YYYY');
          }

          filter.push({
              title: 'Fecha',
              value:  fecha,
          });
        }
      }

      return filter;
    }



  });
}
